/* computer-player.c generated by valac 0.44.0, the Vala compiler
 * generated from computer-player.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2010-2013 Robert Ancell
   Copyright 2013-2014 Michael Catanzaro
   Copyright 2014-2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#define TYPE_COMPUTER_PLAYER (computer_player_get_type ())
#define COMPUTER_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPUTER_PLAYER, ComputerPlayer))
#define COMPUTER_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPUTER_PLAYER, ComputerPlayerClass))
#define IS_COMPUTER_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPUTER_PLAYER))
#define IS_COMPUTER_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPUTER_PLAYER))
#define COMPUTER_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPUTER_PLAYER, ComputerPlayerClass))

typedef struct _ComputerPlayer ComputerPlayer;
typedef struct _ComputerPlayerClass ComputerPlayerClass;
typedef struct _ComputerPlayerPrivate ComputerPlayerPrivate;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
enum  {
	COMPUTER_PLAYER_0_PROPERTY,
	COMPUTER_PLAYER_NUM_PROPERTIES
};
static GParamSpec* computer_player_properties[COMPUTER_PLAYER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _ComputerPlayerMoveAsyncData ComputerPlayerMoveAsyncData;

#define COMPUTER_PLAYER_TYPE_POSSIBLE_MOVE (computer_player_possible_move_get_type ())
typedef struct _ComputerPlayerPossibleMove ComputerPlayerPossibleMove;
#define _computer_player_possible_move_free0(var) ((var == NULL) ? NULL : (var = (computer_player_possible_move_free (var), NULL)))
typedef enum  {
	PLAYER_NONE,
	PLAYER_DARK,
	PLAYER_LIGHT
} Player;

#define TYPE_PLAYER (player_get_type ())
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ComputerPlayer {
	GObject parent_instance;
	ComputerPlayerPrivate * priv;
};

struct _ComputerPlayerClass {
	GObjectClass parent_class;
};

struct _ComputerPlayerPrivate {
	Game* game;
	guint8 difficulty_level;
	guint pending_move_id;
	gboolean _move_pending;
	GRecMutex _move_pending_mutex;
};

struct _Block1Data {
	int _ref_count_;
	ComputerPlayer* self;
	guint8 x;
	guint8 y;
	gpointer _async_data_;
};

struct _ComputerPlayerMoveAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ComputerPlayer* self;
	gdouble delay_seconds;
	Block1Data* _data1_;
	GTimer* timer;
	GTimer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GTimer* _tmp3_;
	GThread* _tmp4_;
	GThread* _tmp5_;
	GTimer* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GTimer* _tmp9_;
	GTimer* _tmp10_;
};

struct _ComputerPlayerPossibleMove {
	guint8 x;
	guint8 y;
	guint8 n_tiles;
};

static gint ComputerPlayer_private_offset;
static gpointer computer_player_parent_class = NULL;

GType computer_player_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ComputerPlayer, g_object_unref)
GType game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
#define COMPUTER_PLAYER_POSITIVE_INFINITY 10000
#define COMPUTER_PLAYER_NEGATIVE_INFINITY -10000
ComputerPlayer* computer_player_new (Game* game,
                                     guint8 difficulty_level);
ComputerPlayer* computer_player_construct (GType object_type,
                                           Game* game,
                                           guint8 difficulty_level);
static void computer_player_complete_move (ComputerPlayer* self,
                                    guint8 x,
                                    guint8 y);
guint8 game_place_tile (Game* self,
                        guint8 x,
                        guint8 y,
                        gboolean apply);
gchar* game_to_string (Game* self);
static void computer_player_random_select (Game* g,
                                    guint8* move_x,
                                    guint8* move_y);
void computer_player_move (ComputerPlayer* self);
static void computer_player_run_search (ComputerPlayer* self,
                                 guint8* x,
                                 guint8* y);
static void computer_player_move_async_data_free (gpointer _data);
void computer_player_move_async (ComputerPlayer* self,
                                 gdouble delay_seconds,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
void computer_player_move_finish (ComputerPlayer* self,
                                  GAsyncResult* _res_);
static gboolean computer_player_move_async_co (ComputerPlayerMoveAsyncData* _data_);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean computer_player_get_move_pending (ComputerPlayer* self);
static gboolean _computer_player_move_async_co_gsource_func (gpointer self);
static void* __lambda4_ (Block1Data* _data1_);
static void computer_player_set_move_pending (ComputerPlayer* self,
                                       gboolean value);
static gpointer ___lambda4__gthread_func (gpointer self);
static gboolean __lambda5_ (Block1Data* _data1_);
static gboolean ___lambda5__gsource_func (gpointer self);
void computer_player_cancel_move (ComputerPlayer* self);
gboolean game_get_current_player_can_move (Game* self);
guint8 game_get_size (Game* self);
guint8 game_get_n_tiles (Game* self);
guint8 game_get_initial_number_of_tiles (Game* self);
Game* game_new_copy (Game* game);
Game* game_construct_copy (GType object_type,
                           Game* game);
static GType computer_player_possible_move_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static ComputerPlayerPossibleMove* computer_player_possible_move_dup (const ComputerPlayerPossibleMove* self);
static void computer_player_possible_move_free (ComputerPlayerPossibleMove* self);
static void computer_player_get_possible_moves_sorted (Game* g,
                                                GList* * moves);
static gint computer_player_search (ComputerPlayer* self,
                             Game* g,
                             gint depth,
                             gint a,
                             gint b);
void game_undo (Game* self,
                guint8 count);
static void _computer_player_possible_move_free0_ (gpointer var);
static inline void _g_list_free__computer_player_possible_move_free0_ (GList* self);
gboolean game_get_is_complete (Game* self);
guint8 game_get_n_current_tiles (Game* self);
guint8 game_get_n_opponent_tiles (Game* self);
static gint computer_player_calculate_heuristic (Game* g,
                                          guint8* difficulty_level);
void game_pass (Game* self);
static void computer_player_possible_move_init (ComputerPlayerPossibleMove *self,
                                         guint8 x,
                                         guint8 y,
                                         guint8 n_tiles);
static gint computer_player_compare_move (ComputerPlayerPossibleMove* a,
                                   ComputerPlayerPossibleMove* b);
static gint _computer_player_compare_move_gcompare_func (gconstpointer a,
                                                  gconstpointer b);
static gint computer_player_eval_heuristic (Game* g);
static gint computer_player_around (Game* g);
GType player_get_type (void) G_GNUC_CONST;
Player game_get_owner (Game* self,
                       guint8 x,
                       guint8 y);
Player game_get_current_color (Game* self);
static gint computer_player_is_empty (Game* g,
                               gint8 x,
                               gint8 y);
gboolean game_is_valid_location_signed (Game* self,
                                        gint8 x,
                                        gint8 y);
gboolean game_can_place (Game* self,
                         guint8 x,
                         guint8 y,
                         Player color);
static void computer_player_finalize (GObject * obj);
static void _vala_computer_player_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_computer_player_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);

static const gint COMPUTER_PLAYER_heuristic[64] = {65, -3, 6, 4, 4, 6, -3, 65, -3, -29, 3, 1, 1, 3, -29, -3, 6, 3, 5, 3, 3, 5, 3, 6, 4, 1, 3, 1, 1, 3, 1, 4, 4, 1, 3, 1, 1, 3, 1, 4, 6, 3, 5, 3, 3, 5, 3, 6, -3, -29, 3, 1, 1, 3, -29, -3, 65, -3, 6, 4, 4, 6, -3, 65};

static inline gpointer
computer_player_get_instance_private (ComputerPlayer* self)
{
	return G_STRUCT_MEMBER_P (self, ComputerPlayer_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 89 "../src/computer-player.vala"
	return self ? g_object_ref (self) : NULL;
#line 262 "computer-player.c"
}

ComputerPlayer*
computer_player_construct (GType object_type,
                           Game* game,
                           guint8 difficulty_level)
{
	ComputerPlayer * self = NULL;
	Game* _tmp0_;
#line 87 "../src/computer-player.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 87 "../src/computer-player.vala"
	self = (ComputerPlayer*) g_object_new (object_type, NULL);
#line 89 "../src/computer-player.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 89 "../src/computer-player.vala"
	_g_object_unref0 (self->priv->game);
#line 89 "../src/computer-player.vala"
	self->priv->game = _tmp0_;
#line 90 "../src/computer-player.vala"
	self->priv->difficulty_level = difficulty_level;
#line 87 "../src/computer-player.vala"
	return self;
#line 286 "computer-player.c"
}

ComputerPlayer*
computer_player_new (Game* game,
                     guint8 difficulty_level)
{
#line 87 "../src/computer-player.vala"
	return computer_player_construct (TYPE_COMPUTER_PLAYER, game, difficulty_level);
#line 295 "computer-player.c"
}

static void
computer_player_complete_move (ComputerPlayer* self,
                               guint8 x,
                               guint8 y)
{
	Game* _tmp0_;
#line 93 "../src/computer-player.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/computer-player.vala"
	_tmp0_ = self->priv->game;
#line 95 "../src/computer-player.vala"
	if (((gint) game_place_tile (_tmp0_, x, y, TRUE)) == 0) {
#line 310 "computer-player.c"
		Game* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		guint8 new_x = 0U;
		guint8 new_y = 0U;
		Game* _tmp4_;
		guint8 _tmp5_ = 0U;
		guint8 _tmp6_ = 0U;
		Game* _tmp7_;
#line 97 "../src/computer-player.vala"
		_tmp1_ = self->priv->game;
#line 97 "../src/computer-player.vala"
		_tmp2_ = game_to_string (_tmp1_);
#line 97 "../src/computer-player.vala"
		_tmp3_ = _tmp2_;
#line 97 "../src/computer-player.vala"
		g_critical ("computer-player.vala:97: Computer chose an invalid move: %d,%d\n%s", (gint) x, (gint) y, _tmp3_);
#line 97 "../src/computer-player.vala"
		_g_free0 (_tmp3_);
#line 102 "../src/computer-player.vala"
		_tmp4_ = self->priv->game;
#line 102 "../src/computer-player.vala"
		computer_player_random_select (_tmp4_, &_tmp5_, &_tmp6_);
#line 102 "../src/computer-player.vala"
		new_x = _tmp5_;
#line 102 "../src/computer-player.vala"
		new_y = _tmp6_;
#line 103 "../src/computer-player.vala"
		_tmp7_ = self->priv->game;
#line 103 "../src/computer-player.vala"
		if (((gint) game_place_tile (_tmp7_, new_x, new_y, TRUE)) == 0) {
#line 342 "computer-player.c"
			Game* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 105 "../src/computer-player.vala"
			_tmp8_ = self->priv->game;
#line 105 "../src/computer-player.vala"
			_tmp9_ = game_to_string (_tmp8_);
#line 105 "../src/computer-player.vala"
			_tmp10_ = _tmp9_;
#line 105 "../src/computer-player.vala"
			g_critical ("computer-player.vala:105: Computer chose an invalid move for the secon" \
"d time: %d,%d\n" \
"%s", (gint) new_x, (gint) new_y, _tmp10_);
#line 105 "../src/computer-player.vala"
			_g_free0 (_tmp10_);
#line 106 "../src/computer-player.vala"
			g_assert_not_reached ();
#line 358 "computer-player.c"
		}
	}
}

void
computer_player_move (ComputerPlayer* self)
{
	guint8 x = 0U;
	guint8 y = 0U;
	guint8 _tmp0_ = 0U;
	guint8 _tmp1_ = 0U;
#line 112 "../src/computer-player.vala"
	g_return_if_fail (self != NULL);
#line 117 "../src/computer-player.vala"
	computer_player_run_search (self, &_tmp0_, &_tmp1_);
#line 117 "../src/computer-player.vala"
	x = _tmp0_;
#line 117 "../src/computer-player.vala"
	y = _tmp1_;
#line 118 "../src/computer-player.vala"
	computer_player_complete_move (self, x, y);
#line 380 "computer-player.c"
}

static void
computer_player_move_async_data_free (gpointer _data)
{
	ComputerPlayerMoveAsyncData* _data_;
	_data_ = _data;
#line 23 "../src/computer-player.vala"
	_g_object_unref0 (_data_->self);
#line 23 "../src/computer-player.vala"
	g_slice_free (ComputerPlayerMoveAsyncData, _data_);
#line 392 "computer-player.c"
}

void
computer_player_move_async (ComputerPlayer* self,
                            gdouble delay_seconds,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	ComputerPlayerMoveAsyncData* _data_;
	ComputerPlayer* _tmp0_;
#line 23 "../src/computer-player.vala"
	_data_ = g_slice_new0 (ComputerPlayerMoveAsyncData);
#line 23 "../src/computer-player.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 23 "../src/computer-player.vala"
	g_task_set_task_data (_data_->_async_result, _data_, computer_player_move_async_data_free);
#line 23 "../src/computer-player.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 23 "../src/computer-player.vala"
	_data_->self = _tmp0_;
#line 23 "../src/computer-player.vala"
	_data_->delay_seconds = delay_seconds;
#line 23 "../src/computer-player.vala"
	computer_player_move_async_co (_data_);
#line 417 "computer-player.c"
}

void
computer_player_move_finish (ComputerPlayer* self,
                             GAsyncResult* _res_)
{
	ComputerPlayerMoveAsyncData* _data_;
#line 23 "../src/computer-player.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 427 "computer-player.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 121 "../src/computer-player.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 121 "../src/computer-player.vala"
	return _data1_;
#line 437 "computer-player.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 121 "../src/computer-player.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 447 "computer-player.c"
		ComputerPlayer* self;
#line 121 "../src/computer-player.vala"
		self = _data1_->self;
#line 121 "../src/computer-player.vala"
		_g_object_unref0 (self);
#line 121 "../src/computer-player.vala"
		g_slice_free (Block1Data, _data1_);
#line 455 "computer-player.c"
	}
}

static gboolean
_computer_player_move_async_co_gsource_func (gpointer self)
{
	gboolean result;
	result = computer_player_move_async_co (self);
#line 131 "../src/computer-player.vala"
	return result;
#line 466 "computer-player.c"
}

static void*
__lambda4_ (Block1Data* _data1_)
{
	ComputerPlayer* self;
	void* result = NULL;
	guint8 _tmp0_ = 0U;
	guint8 _tmp1_ = 0U;
#line 136 "../src/computer-player.vala"
	self = _data1_->self;
#line 137 "../src/computer-player.vala"
	computer_player_set_move_pending (self, TRUE);
#line 138 "../src/computer-player.vala"
	computer_player_run_search (self, &_tmp0_, &_tmp1_);
#line 138 "../src/computer-player.vala"
	_data1_->x = _tmp0_;
#line 138 "../src/computer-player.vala"
	_data1_->y = _tmp1_;
#line 139 "../src/computer-player.vala"
	computer_player_move_async_co (_data1_->_async_data_);
#line 140 "../src/computer-player.vala"
	result = NULL;
#line 140 "../src/computer-player.vala"
	return result;
#line 492 "computer-player.c"
}

static gpointer
___lambda4__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda4_ (self);
#line 136 "../src/computer-player.vala"
	block1_data_unref (self);
#line 136 "../src/computer-player.vala"
	return result;
#line 504 "computer-player.c"
}

static gboolean
__lambda5_ (Block1Data* _data1_)
{
	ComputerPlayer* self;
	gboolean result = FALSE;
#line 159 "../src/computer-player.vala"
	self = _data1_->self;
#line 160 "../src/computer-player.vala"
	computer_player_complete_move (self, _data1_->x, _data1_->y);
#line 161 "../src/computer-player.vala"
	result = G_SOURCE_REMOVE;
#line 161 "../src/computer-player.vala"
	return result;
#line 520 "computer-player.c"
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ (self);
#line 159 "../src/computer-player.vala"
	return result;
#line 530 "computer-player.c"
}

static gboolean
computer_player_move_async_co (ComputerPlayerMoveAsyncData* _data_)
{
#line 121 "../src/computer-player.vala"
	switch (_data_->_state_) {
#line 121 "../src/computer-player.vala"
		case 0:
#line 540 "computer-player.c"
		goto _state_0;
#line 121 "../src/computer-player.vala"
		case 1:
#line 544 "computer-player.c"
		goto _state_1;
#line 121 "../src/computer-player.vala"
		case 2:
#line 548 "computer-player.c"
		goto _state_2;
#line 121 "../src/computer-player.vala"
		case 3:
#line 552 "computer-player.c"
		goto _state_3;
		default:
#line 121 "../src/computer-player.vala"
		g_assert_not_reached ();
#line 557 "computer-player.c"
	}
	_state_0:
#line 121 "../src/computer-player.vala"
	_data_->_data1_ = g_slice_new0 (Block1Data);
#line 121 "../src/computer-player.vala"
	_data_->_data1_->_ref_count_ = 1;
#line 121 "../src/computer-player.vala"
	_data_->_data1_->self = g_object_ref (_data_->self);
#line 121 "../src/computer-player.vala"
	_data_->_data1_->_async_data_ = _data_;
#line 123 "../src/computer-player.vala"
	_data_->_tmp0_ = g_timer_new ();
#line 123 "../src/computer-player.vala"
	_data_->timer = _data_->_tmp0_;
#line 124 "../src/computer-player.vala"
	_data_->_data1_->x = (guint8) 0;
#line 125 "../src/computer-player.vala"
	_data_->_data1_->y = (guint8) 0;
#line 127 "../src/computer-player.vala"
	while (TRUE) {
#line 127 "../src/computer-player.vala"
		_data_->_tmp1_ = computer_player_get_move_pending (_data_->self);
#line 127 "../src/computer-player.vala"
		_data_->_tmp2_ = _data_->_tmp1_;
#line 127 "../src/computer-player.vala"
		if (!_data_->_tmp2_) {
#line 127 "../src/computer-player.vala"
			break;
#line 586 "computer-player.c"
		}
#line 131 "../src/computer-player.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _computer_player_move_async_co_gsource_func, _data_, NULL);
#line 132 "../src/computer-player.vala"
		_data_->_state_ = 1;
#line 132 "../src/computer-player.vala"
		return FALSE;
#line 594 "computer-player.c"
		_state_1:
		;
	}
#line 135 "../src/computer-player.vala"
	_data_->_tmp3_ = _data_->timer;
#line 135 "../src/computer-player.vala"
	g_timer_start (_data_->_tmp3_);
#line 136 "../src/computer-player.vala"
	_data_->_tmp4_ = g_thread_new ("AI thread", ___lambda4__gthread_func, block1_data_ref (_data_->_data1_));
#line 136 "../src/computer-player.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 136 "../src/computer-player.vala"
	_g_thread_unref0 (_data_->_tmp5_);
#line 142 "../src/computer-player.vala"
	_data_->_state_ = 2;
#line 142 "../src/computer-player.vala"
	return FALSE;
#line 612 "computer-player.c"
	_state_2:
	;
#line 144 "../src/computer-player.vala"
	_data_->_tmp6_ = _data_->timer;
#line 144 "../src/computer-player.vala"
	g_timer_stop (_data_->_tmp6_);
#line 146 "../src/computer-player.vala"
	_data_->_tmp7_ = computer_player_get_move_pending (_data_->self);
#line 146 "../src/computer-player.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 146 "../src/computer-player.vala"
	if (!_data_->_tmp8_) {
#line 147 "../src/computer-player.vala"
		_g_timer_destroy0 (_data_->timer);
#line 147 "../src/computer-player.vala"
		block1_data_unref (_data_->_data1_);
#line 147 "../src/computer-player.vala"
		_data_->_data1_ = NULL;
#line 147 "../src/computer-player.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 147 "../src/computer-player.vala"
		if (_data_->_state_ != 0) {
#line 147 "../src/computer-player.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 147 "../src/computer-player.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 639 "computer-player.c"
			}
		}
#line 147 "../src/computer-player.vala"
		g_object_unref (_data_->_async_result);
#line 147 "../src/computer-player.vala"
		return FALSE;
#line 646 "computer-player.c"
	}
#line 149 "../src/computer-player.vala"
	_data_->_tmp9_ = _data_->timer;
#line 149 "../src/computer-player.vala"
	if (g_timer_elapsed (_data_->_tmp9_, NULL) < _data_->delay_seconds) {
#line 151 "../src/computer-player.vala"
		_data_->_tmp10_ = _data_->timer;
#line 151 "../src/computer-player.vala"
		_data_->self->priv->pending_move_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) ((_data_->delay_seconds - g_timer_elapsed (_data_->_tmp10_, NULL)) * 1000), _computer_player_move_async_co_gsource_func, _data_, NULL);
#line 152 "../src/computer-player.vala"
		_data_->_state_ = 3;
#line 152 "../src/computer-player.vala"
		return FALSE;
#line 660 "computer-player.c"
		_state_3:
		;
	}
#line 155 "../src/computer-player.vala"
	_data_->self->priv->pending_move_id = (guint) 0;
#line 156 "../src/computer-player.vala"
	computer_player_set_move_pending (_data_->self, FALSE);
#line 159 "../src/computer-player.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda5__gsource_func, block1_data_ref (_data_->_data1_), block1_data_unref);
#line 121 "../src/computer-player.vala"
	_g_timer_destroy0 (_data_->timer);
#line 121 "../src/computer-player.vala"
	block1_data_unref (_data_->_data1_);
#line 121 "../src/computer-player.vala"
	_data_->_data1_ = NULL;
#line 121 "../src/computer-player.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 121 "../src/computer-player.vala"
	if (_data_->_state_ != 0) {
#line 121 "../src/computer-player.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 121 "../src/computer-player.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 684 "computer-player.c"
		}
	}
#line 121 "../src/computer-player.vala"
	g_object_unref (_data_->_async_result);
#line 121 "../src/computer-player.vala"
	return FALSE;
#line 691 "computer-player.c"
}

void
computer_player_cancel_move (ComputerPlayer* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 165 "../src/computer-player.vala"
	g_return_if_fail (self != NULL);
#line 167 "../src/computer-player.vala"
	_tmp0_ = computer_player_get_move_pending (self);
#line 167 "../src/computer-player.vala"
	_tmp1_ = _tmp0_;
#line 167 "../src/computer-player.vala"
	if (!_tmp1_) {
#line 168 "../src/computer-player.vala"
		return;
#line 709 "computer-player.c"
	}
#line 171 "../src/computer-player.vala"
	if (self->priv->pending_move_id != ((guint) 0)) {
#line 173 "../src/computer-player.vala"
		g_source_remove (self->priv->pending_move_id);
#line 174 "../src/computer-player.vala"
		self->priv->pending_move_id = (guint) 0;
#line 717 "computer-player.c"
	}
#line 179 "../src/computer-player.vala"
	computer_player_set_move_pending (self, FALSE);
#line 721 "computer-player.c"
}

static gpointer
_computer_player_possible_move_dup0 (gpointer self)
{
#line 211 "../src/computer-player.vala"
	return self ? computer_player_possible_move_dup (self) : NULL;
#line 729 "computer-player.c"
}

static void
_computer_player_possible_move_free0_ (gpointer var)
{
#line 186 "../src/computer-player.vala"
	(var == NULL) ? NULL : (var = (computer_player_possible_move_free (var), NULL));
#line 737 "computer-player.c"
}

static inline void
_g_list_free__computer_player_possible_move_free0_ (GList* self)
{
#line 186 "../src/computer-player.vala"
	g_list_free_full (self, (GDestroyNotify) _computer_player_possible_move_free0_);
#line 745 "computer-player.c"
}

static void
computer_player_run_search (ComputerPlayer* self,
                            guint8* x,
                            guint8* y)
{
	guint8 _vala_x = 0U;
	guint8 _vala_y = 0U;
	Game* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint _tmp3_ = 0;
	Game* _tmp4_;
	guint8 _tmp5_;
	guint8 _tmp6_;
	Game* _tmp7_;
	guint8 _tmp8_;
	guint8 _tmp9_;
	Game* _tmp10_;
	guint8 _tmp11_;
	guint8 _tmp12_;
	Game* g = NULL;
	Game* _tmp16_;
	Game* _tmp17_;
	gint depth = 0;
	gint a = 0;
	GList* moves = NULL;
	Game* _tmp18_;
	GList* _tmp19_;
#line 186 "../src/computer-player.vala"
	g_return_if_fail (self != NULL);
#line 186 "../src/computer-player.vala"
	_tmp0_ = self->priv->game;
#line 186 "../src/computer-player.vala"
	_tmp1_ = game_get_current_player_can_move (_tmp0_);
#line 186 "../src/computer-player.vala"
	_tmp2_ = _tmp1_;
#line 186 "../src/computer-player.vala"
	_vala_return_if_fail (_tmp2_, "game.current_player_can_move");
#line 190 "../src/computer-player.vala"
	_tmp4_ = self->priv->game;
#line 190 "../src/computer-player.vala"
	_tmp5_ = game_get_size (_tmp4_);
#line 190 "../src/computer-player.vala"
	_tmp6_ = _tmp5_;
#line 190 "../src/computer-player.vala"
	if (((gint) _tmp6_) < 6) {
#line 190 "../src/computer-player.vala"
		_tmp3_ = 2;
#line 796 "computer-player.c"
	} else {
#line 190 "../src/computer-player.vala"
		_tmp3_ = 4;
#line 800 "computer-player.c"
	}
#line 190 "../src/computer-player.vala"
	_tmp7_ = self->priv->game;
#line 190 "../src/computer-player.vala"
	_tmp8_ = game_get_n_tiles (_tmp7_);
#line 190 "../src/computer-player.vala"
	_tmp9_ = _tmp8_;
#line 190 "../src/computer-player.vala"
	_tmp10_ = self->priv->game;
#line 190 "../src/computer-player.vala"
	_tmp11_ = game_get_initial_number_of_tiles (_tmp10_);
#line 190 "../src/computer-player.vala"
	_tmp12_ = _tmp11_;
#line 190 "../src/computer-player.vala"
	if (((gint) _tmp9_) < (_tmp12_ + _tmp3_)) {
#line 816 "computer-player.c"
		Game* _tmp13_;
		guint8 _tmp14_ = 0U;
		guint8 _tmp15_ = 0U;
#line 192 "../src/computer-player.vala"
		_tmp13_ = self->priv->game;
#line 192 "../src/computer-player.vala"
		computer_player_random_select (_tmp13_, &_tmp14_, &_tmp15_);
#line 192 "../src/computer-player.vala"
		_vala_x = _tmp14_;
#line 192 "../src/computer-player.vala"
		_vala_y = _tmp15_;
#line 193 "../src/computer-player.vala"
		if (x) {
#line 193 "../src/computer-player.vala"
			*x = _vala_x;
#line 832 "computer-player.c"
		}
#line 193 "../src/computer-player.vala"
		if (y) {
#line 193 "../src/computer-player.vala"
			*y = _vala_y;
#line 838 "computer-player.c"
		}
#line 193 "../src/computer-player.vala"
		return;
#line 842 "computer-player.c"
	}
#line 196 "../src/computer-player.vala"
	_vala_x = (guint8) 0;
#line 197 "../src/computer-player.vala"
	_vala_y = (guint8) 0;
#line 202 "../src/computer-player.vala"
	_tmp16_ = self->priv->game;
#line 202 "../src/computer-player.vala"
	_tmp17_ = game_new_copy (_tmp16_);
#line 202 "../src/computer-player.vala"
	g = _tmp17_;
#line 203 "../src/computer-player.vala"
	depth = self->priv->difficulty_level * 2;
#line 205 "../src/computer-player.vala"
	a = COMPUTER_PLAYER_NEGATIVE_INFINITY - 1;
#line 207 "../src/computer-player.vala"
	moves = NULL;
#line 208 "../src/computer-player.vala"
	_tmp18_ = g;
#line 208 "../src/computer-player.vala"
	computer_player_get_possible_moves_sorted (_tmp18_, &moves);
#line 211 "../src/computer-player.vala"
	_tmp19_ = moves;
#line 866 "computer-player.c"
	{
		GList* move_collection = NULL;
		GList* move_it = NULL;
#line 211 "../src/computer-player.vala"
		move_collection = _tmp19_;
#line 211 "../src/computer-player.vala"
		for (move_it = move_collection; move_it != NULL; move_it = move_it->next) {
#line 874 "computer-player.c"
			ComputerPlayerPossibleMove* _tmp20_;
			ComputerPlayerPossibleMove* move = NULL;
#line 211 "../src/computer-player.vala"
			_tmp20_ = _computer_player_possible_move_dup0 ((ComputerPlayerPossibleMove*) move_it->data);
#line 211 "../src/computer-player.vala"
			move = _tmp20_;
#line 881 "computer-player.c"
			{
				ComputerPlayerPossibleMove* _tmp21_;
				Game* _tmp22_;
				ComputerPlayerPossibleMove* _tmp23_;
				ComputerPlayerPossibleMove* _tmp24_;
				gint a_new = 0;
				Game* _tmp31_;
				Game* _tmp34_;
#line 213 "../src/computer-player.vala"
				_tmp21_ = move;
#line 213 "../src/computer-player.vala"
				if (_tmp21_ == NULL) {
#line 214 "../src/computer-player.vala"
					g_assert_not_reached ();
#line 896 "computer-player.c"
				}
#line 216 "../src/computer-player.vala"
				_tmp22_ = g;
#line 216 "../src/computer-player.vala"
				_tmp23_ = move;
#line 216 "../src/computer-player.vala"
				_tmp24_ = move;
#line 216 "../src/computer-player.vala"
				if (((gint) game_place_tile (_tmp22_, ((ComputerPlayerPossibleMove) (*_tmp23_)).x, ((ComputerPlayerPossibleMove) (*_tmp24_)).y, TRUE)) == 0) {
#line 906 "computer-player.c"
					ComputerPlayerPossibleMove* _tmp25_;
					ComputerPlayerPossibleMove* _tmp26_;
					ComputerPlayerPossibleMove* _tmp27_;
					Game* _tmp28_;
					gchar* _tmp29_;
					gchar* _tmp30_;
#line 218 "../src/computer-player.vala"
					_tmp25_ = move;
#line 218 "../src/computer-player.vala"
					_tmp26_ = move;
#line 218 "../src/computer-player.vala"
					_tmp27_ = move;
#line 218 "../src/computer-player.vala"
					_tmp28_ = g;
#line 218 "../src/computer-player.vala"
					_tmp29_ = game_to_string (_tmp28_);
#line 218 "../src/computer-player.vala"
					_tmp30_ = _tmp29_;
#line 218 "../src/computer-player.vala"
					g_critical ("computer-player.vala:218: Computer marked move (depth %d, %d,%d, %d fl" \
"ips) as valid, but is invalid when checking.\n" \
"%s", depth, (gint) ((ComputerPlayerPossibleMove) (*_tmp25_)).x, (gint) ((ComputerPlayerPossibleMove) (*_tmp26_)).y, (gint) ((ComputerPlayerPossibleMove) (*_tmp27_)).n_tiles, _tmp30_);
#line 218 "../src/computer-player.vala"
					_g_free0 (_tmp30_);
#line 219 "../src/computer-player.vala"
					g_assert_not_reached ();
#line 931 "computer-player.c"
				}
#line 222 "../src/computer-player.vala"
				_tmp31_ = g;
#line 222 "../src/computer-player.vala"
				a_new = -1 * computer_player_search (self, _tmp31_, depth, COMPUTER_PLAYER_NEGATIVE_INFINITY, -a);
#line 223 "../src/computer-player.vala"
				if (a_new > a) {
#line 939 "computer-player.c"
					ComputerPlayerPossibleMove* _tmp32_;
					ComputerPlayerPossibleMove* _tmp33_;
#line 225 "../src/computer-player.vala"
					a = a_new;
#line 226 "../src/computer-player.vala"
					_tmp32_ = move;
#line 226 "../src/computer-player.vala"
					_vala_x = ((ComputerPlayerPossibleMove) (*_tmp32_)).x;
#line 227 "../src/computer-player.vala"
					_tmp33_ = move;
#line 227 "../src/computer-player.vala"
					_vala_y = ((ComputerPlayerPossibleMove) (*_tmp33_)).y;
#line 952 "computer-player.c"
				}
#line 230 "../src/computer-player.vala"
				_tmp34_ = g;
#line 230 "../src/computer-player.vala"
				game_undo (_tmp34_, (guint8) 1);
#line 211 "../src/computer-player.vala"
				_computer_player_possible_move_free0 (move);
#line 960 "computer-player.c"
			}
		}
	}
#line 186 "../src/computer-player.vala"
	(moves == NULL) ? NULL : (moves = (_g_list_free__computer_player_possible_move_free0_ (moves), NULL));
#line 186 "../src/computer-player.vala"
	_g_object_unref0 (g);
#line 186 "../src/computer-player.vala"
	if (x) {
#line 186 "../src/computer-player.vala"
		*x = _vala_x;
#line 972 "computer-player.c"
	}
#line 186 "../src/computer-player.vala"
	if (y) {
#line 186 "../src/computer-player.vala"
		*y = _vala_y;
#line 978 "computer-player.c"
	}
}

static gint
computer_player_search (ComputerPlayer* self,
                        Game* g,
                        gint depth,
                        gint a,
                        gint b)
{
	gint result = 0;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp14_;
	gboolean _tmp15_;
#line 234 "../src/computer-player.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 234 "../src/computer-player.vala"
	g_return_val_if_fail (g != NULL, 0);
#line 234 "../src/computer-player.vala"
	_vala_return_val_if_fail (a <= b, "a <= b", 0);
#line 238 "../src/computer-player.vala"
	_tmp0_ = game_get_is_complete (g);
#line 238 "../src/computer-player.vala"
	_tmp1_ = _tmp0_;
#line 238 "../src/computer-player.vala"
	if (_tmp1_) {
#line 1008 "computer-player.c"
		gint _tmp2_ = 0;
		guint8 _tmp3_;
		guint8 _tmp4_;
		guint8 _tmp5_;
		guint8 _tmp6_;
#line 239 "../src/computer-player.vala"
		_tmp3_ = game_get_n_current_tiles (g);
#line 239 "../src/computer-player.vala"
		_tmp4_ = _tmp3_;
#line 239 "../src/computer-player.vala"
		_tmp5_ = game_get_n_opponent_tiles (g);
#line 239 "../src/computer-player.vala"
		_tmp6_ = _tmp5_;
#line 239 "../src/computer-player.vala"
		if (_tmp4_ > _tmp6_) {
#line 1024 "computer-player.c"
			guint8 _tmp7_;
			guint8 _tmp8_;
#line 239 "../src/computer-player.vala"
			_tmp7_ = game_get_n_opponent_tiles (g);
#line 239 "../src/computer-player.vala"
			_tmp8_ = _tmp7_;
#line 239 "../src/computer-player.vala"
			_tmp2_ = COMPUTER_PLAYER_POSITIVE_INFINITY - _tmp8_;
#line 1033 "computer-player.c"
		} else {
			guint8 _tmp9_;
			guint8 _tmp10_;
#line 239 "../src/computer-player.vala"
			_tmp9_ = game_get_n_current_tiles (g);
#line 239 "../src/computer-player.vala"
			_tmp10_ = _tmp9_;
#line 239 "../src/computer-player.vala"
			_tmp2_ = COMPUTER_PLAYER_NEGATIVE_INFINITY + _tmp10_;
#line 1043 "computer-player.c"
		}
#line 239 "../src/computer-player.vala"
		result = _tmp2_;
#line 239 "../src/computer-player.vala"
		return result;
#line 1049 "computer-player.c"
	}
#line 243 "../src/computer-player.vala"
	_tmp11_ = computer_player_get_move_pending (self);
#line 243 "../src/computer-player.vala"
	_tmp12_ = _tmp11_;
#line 243 "../src/computer-player.vala"
	if (!_tmp12_) {
#line 244 "../src/computer-player.vala"
		result = 0;
#line 244 "../src/computer-player.vala"
		return result;
#line 1061 "computer-player.c"
	}
#line 247 "../src/computer-player.vala"
	if (depth == 0) {
#line 1065 "computer-player.c"
		gint _tmp13_;
#line 248 "../src/computer-player.vala"
		_tmp13_ = computer_player_calculate_heuristic (g, &self->priv->difficulty_level);
#line 248 "../src/computer-player.vala"
		result = _tmp13_;
#line 248 "../src/computer-player.vala"
		return result;
#line 1073 "computer-player.c"
	}
#line 250 "../src/computer-player.vala"
	_tmp14_ = game_get_current_player_can_move (g);
#line 250 "../src/computer-player.vala"
	_tmp15_ = _tmp14_;
#line 250 "../src/computer-player.vala"
	if (_tmp15_) {
#line 1081 "computer-player.c"
		GList* moves = NULL;
		GList* _tmp16_;
#line 252 "../src/computer-player.vala"
		moves = NULL;
#line 253 "../src/computer-player.vala"
		computer_player_get_possible_moves_sorted (g, &moves);
#line 256 "../src/computer-player.vala"
		_tmp16_ = moves;
#line 1090 "computer-player.c"
		{
			GList* move_collection = NULL;
			GList* move_it = NULL;
#line 256 "../src/computer-player.vala"
			move_collection = _tmp16_;
#line 256 "../src/computer-player.vala"
			for (move_it = move_collection; move_it != NULL; move_it = move_it->next) {
#line 1098 "computer-player.c"
				ComputerPlayerPossibleMove* _tmp17_;
				ComputerPlayerPossibleMove* move = NULL;
#line 256 "../src/computer-player.vala"
				_tmp17_ = _computer_player_possible_move_dup0 ((ComputerPlayerPossibleMove*) move_it->data);
#line 256 "../src/computer-player.vala"
				move = _tmp17_;
#line 1105 "computer-player.c"
				{
					ComputerPlayerPossibleMove* _tmp18_;
					ComputerPlayerPossibleMove* _tmp19_;
					ComputerPlayerPossibleMove* _tmp20_;
					gint a_new = 0;
#line 258 "../src/computer-player.vala"
					_tmp18_ = move;
#line 258 "../src/computer-player.vala"
					if (_tmp18_ == NULL) {
#line 259 "../src/computer-player.vala"
						g_assert_not_reached ();
#line 1117 "computer-player.c"
					}
#line 261 "../src/computer-player.vala"
					_tmp19_ = move;
#line 261 "../src/computer-player.vala"
					_tmp20_ = move;
#line 261 "../src/computer-player.vala"
					if (((gint) game_place_tile (g, ((ComputerPlayerPossibleMove) (*_tmp19_)).x, ((ComputerPlayerPossibleMove) (*_tmp20_)).y, TRUE)) == 0) {
#line 1125 "computer-player.c"
						ComputerPlayerPossibleMove* _tmp21_;
						ComputerPlayerPossibleMove* _tmp22_;
						ComputerPlayerPossibleMove* _tmp23_;
						gchar* _tmp24_;
						gchar* _tmp25_;
#line 263 "../src/computer-player.vala"
						_tmp21_ = move;
#line 263 "../src/computer-player.vala"
						_tmp22_ = move;
#line 263 "../src/computer-player.vala"
						_tmp23_ = move;
#line 263 "../src/computer-player.vala"
						_tmp24_ = game_to_string (g);
#line 263 "../src/computer-player.vala"
						_tmp25_ = _tmp24_;
#line 263 "../src/computer-player.vala"
						g_critical ("computer-player.vala:263: Computer marked move (depth %d, %d,%d, %d fl" \
"ips) as valid, but is invalid when checking.\n" \
"%s", depth, (gint) ((ComputerPlayerPossibleMove) (*_tmp21_)).x, (gint) ((ComputerPlayerPossibleMove) (*_tmp22_)).y, (gint) ((ComputerPlayerPossibleMove) (*_tmp23_)).n_tiles, _tmp25_);
#line 263 "../src/computer-player.vala"
						_g_free0 (_tmp25_);
#line 264 "../src/computer-player.vala"
						g_assert_not_reached ();
#line 1147 "computer-player.c"
					}
#line 267 "../src/computer-player.vala"
					a_new = -1 * computer_player_search (self, g, depth - 1, -b, -a);
#line 268 "../src/computer-player.vala"
					if (a_new > a) {
#line 269 "../src/computer-player.vala"
						a = a_new;
#line 1155 "computer-player.c"
					}
#line 271 "../src/computer-player.vala"
					game_undo (g, (guint8) 1);
#line 274 "../src/computer-player.vala"
					if (b <= a) {
#line 275 "../src/computer-player.vala"
						_computer_player_possible_move_free0 (move);
#line 275 "../src/computer-player.vala"
						break;
#line 1165 "computer-player.c"
					}
#line 256 "../src/computer-player.vala"
					_computer_player_possible_move_free0 (move);
#line 1169 "computer-player.c"
				}
			}
		}
#line 250 "../src/computer-player.vala"
		(moves == NULL) ? NULL : (moves = (_g_list_free__computer_player_possible_move_free0_ (moves), NULL));
#line 1175 "computer-player.c"
	} else {
		gint a_new = 0;
#line 280 "../src/computer-player.vala"
		game_pass (g);
#line 282 "../src/computer-player.vala"
		a_new = -1 * computer_player_search (self, g, depth - 1, -b, -a);
#line 283 "../src/computer-player.vala"
		if (a_new > a) {
#line 284 "../src/computer-player.vala"
			a = a_new;
#line 1186 "computer-player.c"
		}
#line 286 "../src/computer-player.vala"
		game_undo (g, (guint8) 1);
#line 1190 "computer-player.c"
	}
#line 289 "../src/computer-player.vala"
	result = a;
#line 289 "../src/computer-player.vala"
	return result;
#line 1196 "computer-player.c"
}

static gint
_computer_player_compare_move_gcompare_func (gconstpointer a,
                                             gconstpointer b)
{
	gint result;
	result = computer_player_compare_move ((ComputerPlayerPossibleMove*) a, (ComputerPlayerPossibleMove*) b);
#line 303 "../src/computer-player.vala"
	return result;
#line 1207 "computer-player.c"
}

static void
computer_player_get_possible_moves_sorted (Game* g,
                                           GList* * moves)
{
#line 292 "../src/computer-player.vala"
	g_return_if_fail (g != NULL);
#line 1216 "computer-player.c"
	{
		guint8 x = 0U;
#line 294 "../src/computer-player.vala"
		x = (guint8) 0;
#line 1221 "computer-player.c"
		{
			gboolean _tmp0_ = FALSE;
#line 294 "../src/computer-player.vala"
			_tmp0_ = TRUE;
#line 294 "../src/computer-player.vala"
			while (TRUE) {
#line 1228 "computer-player.c"
				guint8 _tmp2_;
				guint8 _tmp3_;
#line 294 "../src/computer-player.vala"
				if (!_tmp0_) {
#line 1233 "computer-player.c"
					guint8 _tmp1_;
#line 294 "../src/computer-player.vala"
					_tmp1_ = x;
#line 294 "../src/computer-player.vala"
					x = _tmp1_ + 1;
#line 1239 "computer-player.c"
				}
#line 294 "../src/computer-player.vala"
				_tmp0_ = FALSE;
#line 294 "../src/computer-player.vala"
				_tmp2_ = game_get_size (g);
#line 294 "../src/computer-player.vala"
				_tmp3_ = _tmp2_;
#line 294 "../src/computer-player.vala"
				if (!(x < _tmp3_)) {
#line 294 "../src/computer-player.vala"
					break;
#line 1251 "computer-player.c"
				}
				{
					guint8 y = 0U;
#line 296 "../src/computer-player.vala"
					y = (guint8) 0;
#line 1257 "computer-player.c"
					{
						gboolean _tmp4_ = FALSE;
#line 296 "../src/computer-player.vala"
						_tmp4_ = TRUE;
#line 296 "../src/computer-player.vala"
						while (TRUE) {
#line 1264 "computer-player.c"
							guint8 _tmp6_;
							guint8 _tmp7_;
							guint8 n_tiles = 0U;
							ComputerPlayerPossibleMove move = {0};
							ComputerPlayerPossibleMove _tmp8_;
							ComputerPlayerPossibleMove* _tmp9_;
#line 296 "../src/computer-player.vala"
							if (!_tmp4_) {
#line 1273 "computer-player.c"
								guint8 _tmp5_;
#line 296 "../src/computer-player.vala"
								_tmp5_ = y;
#line 296 "../src/computer-player.vala"
								y = _tmp5_ + 1;
#line 1279 "computer-player.c"
							}
#line 296 "../src/computer-player.vala"
							_tmp4_ = FALSE;
#line 296 "../src/computer-player.vala"
							_tmp6_ = game_get_size (g);
#line 296 "../src/computer-player.vala"
							_tmp7_ = _tmp6_;
#line 296 "../src/computer-player.vala"
							if (!(y < _tmp7_)) {
#line 296 "../src/computer-player.vala"
								break;
#line 1291 "computer-player.c"
							}
#line 298 "../src/computer-player.vala"
							n_tiles = game_place_tile (g, x, y, FALSE);
#line 299 "../src/computer-player.vala"
							if (((gint) n_tiles) == 0) {
#line 300 "../src/computer-player.vala"
								continue;
#line 1299 "computer-player.c"
							}
#line 302 "../src/computer-player.vala"
							computer_player_possible_move_init (&move, x, y, n_tiles);
#line 303 "../src/computer-player.vala"
							_tmp8_ = move;
#line 303 "../src/computer-player.vala"
							_tmp9_ = _computer_player_possible_move_dup0 (&_tmp8_);
#line 303 "../src/computer-player.vala"
							*moves = g_list_insert_sorted (*moves, _tmp9_, _computer_player_compare_move_gcompare_func);
#line 1309 "computer-player.c"
						}
					}
				}
			}
		}
	}
}

static gint
computer_player_compare_move (ComputerPlayerPossibleMove* a,
                              ComputerPlayerPossibleMove* b)
{
	gint result = 0;
	gboolean _tmp0_ = FALSE;
#line 310 "../src/computer-player.vala"
	if (a == NULL) {
#line 310 "../src/computer-player.vala"
		_tmp0_ = TRUE;
#line 1328 "computer-player.c"
	} else {
#line 310 "../src/computer-player.vala"
		_tmp0_ = b == NULL;
#line 1332 "computer-player.c"
	}
#line 310 "../src/computer-player.vala"
	if (_tmp0_) {
#line 311 "../src/computer-player.vala"
		g_assert_not_reached ();
#line 1338 "computer-player.c"
	}
#line 312 "../src/computer-player.vala"
	result = (gint) (((ComputerPlayerPossibleMove) (*b)).n_tiles - ((ComputerPlayerPossibleMove) (*a)).n_tiles);
#line 312 "../src/computer-player.vala"
	return result;
#line 1344 "computer-player.c"
}

static gint
computer_player_calculate_heuristic (Game* g,
                                     guint8* difficulty_level)
{
	gint result = 0;
	gint tile_difference = 0;
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
#line 319 "../src/computer-player.vala"
	g_return_val_if_fail (g != NULL, 0);
#line 321 "../src/computer-player.vala"
	_tmp0_ = game_get_n_current_tiles (g);
#line 321 "../src/computer-player.vala"
	_tmp1_ = _tmp0_;
#line 321 "../src/computer-player.vala"
	_tmp2_ = game_get_n_opponent_tiles (g);
#line 321 "../src/computer-player.vala"
	_tmp3_ = _tmp2_;
#line 321 "../src/computer-player.vala"
	tile_difference = (gint) (_tmp1_ - _tmp3_);
#line 324 "../src/computer-player.vala"
	if (((gint) (*difficulty_level)) == 1) {
#line 325 "../src/computer-player.vala"
		result = -tile_difference;
#line 325 "../src/computer-player.vala"
		return result;
#line 1377 "computer-player.c"
	}
#line 328 "../src/computer-player.vala"
	_tmp4_ = game_get_n_tiles (g);
#line 328 "../src/computer-player.vala"
	_tmp5_ = _tmp4_;
#line 328 "../src/computer-player.vala"
	if (((gint) _tmp5_) >= 54) {
#line 329 "../src/computer-player.vala"
		result = tile_difference;
#line 329 "../src/computer-player.vala"
		return result;
#line 1389 "computer-player.c"
	}
#line 332 "../src/computer-player.vala"
	result = (tile_difference + computer_player_eval_heuristic (g)) + computer_player_around (g);
#line 332 "../src/computer-player.vala"
	return result;
#line 1395 "computer-player.c"
}

static gint
computer_player_eval_heuristic (Game* g)
{
	gint result = 0;
	guint8 _tmp0_;
	guint8 _tmp1_;
	gint count = 0;
#line 335 "../src/computer-player.vala"
	g_return_val_if_fail (g != NULL, 0);
#line 337 "../src/computer-player.vala"
	_tmp0_ = game_get_size (g);
#line 337 "../src/computer-player.vala"
	_tmp1_ = _tmp0_;
#line 337 "../src/computer-player.vala"
	if (((gint) _tmp1_) != 8) {
#line 338 "../src/computer-player.vala"
		result = 0;
#line 338 "../src/computer-player.vala"
		return result;
#line 1417 "computer-player.c"
	}
#line 340 "../src/computer-player.vala"
	count = 0;
#line 1421 "computer-player.c"
	{
		guint8 x = 0U;
#line 342 "../src/computer-player.vala"
		x = (guint8) 0;
#line 1426 "computer-player.c"
		{
			gboolean _tmp2_ = FALSE;
#line 342 "../src/computer-player.vala"
			_tmp2_ = TRUE;
#line 342 "../src/computer-player.vala"
			while (TRUE) {
#line 1433 "computer-player.c"
				guint8 _tmp4_;
				guint8 _tmp5_;
#line 342 "../src/computer-player.vala"
				if (!_tmp2_) {
#line 1438 "computer-player.c"
					guint8 _tmp3_;
#line 342 "../src/computer-player.vala"
					_tmp3_ = x;
#line 342 "../src/computer-player.vala"
					x = _tmp3_ + 1;
#line 1444 "computer-player.c"
				}
#line 342 "../src/computer-player.vala"
				_tmp2_ = FALSE;
#line 342 "../src/computer-player.vala"
				_tmp4_ = game_get_size (g);
#line 342 "../src/computer-player.vala"
				_tmp5_ = _tmp4_;
#line 342 "../src/computer-player.vala"
				if (!(x < _tmp5_)) {
#line 342 "../src/computer-player.vala"
					break;
#line 1456 "computer-player.c"
				}
				{
					guint8 y = 0U;
#line 344 "../src/computer-player.vala"
					y = (guint8) 0;
#line 1462 "computer-player.c"
					{
						gboolean _tmp6_ = FALSE;
#line 344 "../src/computer-player.vala"
						_tmp6_ = TRUE;
#line 344 "../src/computer-player.vala"
						while (TRUE) {
#line 1469 "computer-player.c"
							guint8 _tmp8_;
							guint8 _tmp9_;
							gint h = 0;
							guint8 _tmp10_;
							guint8 _tmp11_;
							gint _tmp12_;
							Player _tmp13_;
							Player _tmp14_;
#line 344 "../src/computer-player.vala"
							if (!_tmp6_) {
#line 1480 "computer-player.c"
								guint8 _tmp7_;
#line 344 "../src/computer-player.vala"
								_tmp7_ = y;
#line 344 "../src/computer-player.vala"
								y = _tmp7_ + 1;
#line 1486 "computer-player.c"
							}
#line 344 "../src/computer-player.vala"
							_tmp6_ = FALSE;
#line 344 "../src/computer-player.vala"
							_tmp8_ = game_get_size (g);
#line 344 "../src/computer-player.vala"
							_tmp9_ = _tmp8_;
#line 344 "../src/computer-player.vala"
							if (!(y < _tmp9_)) {
#line 344 "../src/computer-player.vala"
								break;
#line 1498 "computer-player.c"
							}
#line 346 "../src/computer-player.vala"
							_tmp10_ = game_get_size (g);
#line 346 "../src/computer-player.vala"
							_tmp11_ = _tmp10_;
#line 346 "../src/computer-player.vala"
							_tmp12_ = COMPUTER_PLAYER_heuristic[(y * _tmp11_) + x];
#line 346 "../src/computer-player.vala"
							h = _tmp12_;
#line 347 "../src/computer-player.vala"
							_tmp13_ = game_get_current_color (g);
#line 347 "../src/computer-player.vala"
							_tmp14_ = _tmp13_;
#line 347 "../src/computer-player.vala"
							if (game_get_owner (g, x, y) != _tmp14_) {
#line 348 "../src/computer-player.vala"
								h = -h;
#line 1516 "computer-player.c"
							}
#line 349 "../src/computer-player.vala"
							count = count + h;
#line 1520 "computer-player.c"
						}
					}
				}
			}
		}
	}
#line 353 "../src/computer-player.vala"
	result = count;
#line 353 "../src/computer-player.vala"
	return result;
#line 1531 "computer-player.c"
}

static gint
computer_player_around (Game* g)
{
	gint result = 0;
	gint count = 0;
#line 356 "../src/computer-player.vala"
	g_return_val_if_fail (g != NULL, 0);
#line 358 "../src/computer-player.vala"
	count = 0;
#line 1543 "computer-player.c"
	{
		gint8 x = 0;
#line 359 "../src/computer-player.vala"
		x = (gint8) 0;
#line 1548 "computer-player.c"
		{
			gboolean _tmp0_ = FALSE;
#line 359 "../src/computer-player.vala"
			_tmp0_ = TRUE;
#line 359 "../src/computer-player.vala"
			while (TRUE) {
#line 1555 "computer-player.c"
				guint8 _tmp2_;
				guint8 _tmp3_;
#line 359 "../src/computer-player.vala"
				if (!_tmp0_) {
#line 1560 "computer-player.c"
					gint8 _tmp1_;
#line 359 "../src/computer-player.vala"
					_tmp1_ = x;
#line 359 "../src/computer-player.vala"
					x = _tmp1_ + 1;
#line 1566 "computer-player.c"
				}
#line 359 "../src/computer-player.vala"
				_tmp0_ = FALSE;
#line 359 "../src/computer-player.vala"
				_tmp2_ = game_get_size (g);
#line 359 "../src/computer-player.vala"
				_tmp3_ = _tmp2_;
#line 359 "../src/computer-player.vala"
				if (!(x < ((gint8) _tmp3_))) {
#line 359 "../src/computer-player.vala"
					break;
#line 1578 "computer-player.c"
				}
				{
					gint8 y = 0;
#line 361 "../src/computer-player.vala"
					y = (gint8) 0;
#line 1584 "computer-player.c"
					{
						gboolean _tmp4_ = FALSE;
#line 361 "../src/computer-player.vala"
						_tmp4_ = TRUE;
#line 361 "../src/computer-player.vala"
						while (TRUE) {
#line 1591 "computer-player.c"
							guint8 _tmp6_;
							guint8 _tmp7_;
							gint a = 0;
							gint _tmp8_ = 0;
							Player _tmp9_;
							Player _tmp10_;
#line 361 "../src/computer-player.vala"
							if (!_tmp4_) {
#line 1600 "computer-player.c"
								gint8 _tmp5_;
#line 361 "../src/computer-player.vala"
								_tmp5_ = y;
#line 361 "../src/computer-player.vala"
								y = _tmp5_ + 1;
#line 1606 "computer-player.c"
							}
#line 361 "../src/computer-player.vala"
							_tmp4_ = FALSE;
#line 361 "../src/computer-player.vala"
							_tmp6_ = game_get_size (g);
#line 361 "../src/computer-player.vala"
							_tmp7_ = _tmp6_;
#line 361 "../src/computer-player.vala"
							if (!(y < ((gint8) _tmp7_))) {
#line 361 "../src/computer-player.vala"
								break;
#line 1618 "computer-player.c"
							}
#line 363 "../src/computer-player.vala"
							a = 0;
#line 364 "../src/computer-player.vala"
							a = a - computer_player_is_empty (g, (gint8) (x + 1), y);
#line 365 "../src/computer-player.vala"
							a = a - computer_player_is_empty (g, (gint8) (x + 1), (gint8) (y + 1));
#line 366 "../src/computer-player.vala"
							a = a - computer_player_is_empty (g, x, (gint8) (y + 1));
#line 367 "../src/computer-player.vala"
							a = a - computer_player_is_empty (g, (gint8) (x - 1), (gint8) (y + 1));
#line 368 "../src/computer-player.vala"
							a = a - computer_player_is_empty (g, (gint8) (x - 1), y);
#line 369 "../src/computer-player.vala"
							a = a - computer_player_is_empty (g, (gint8) (x - 1), (gint8) (y - 1));
#line 370 "../src/computer-player.vala"
							a = a - computer_player_is_empty (g, x, (gint8) (y - 1));
#line 371 "../src/computer-player.vala"
							a = a - computer_player_is_empty (g, (gint8) (x + 1), (gint8) (y - 1));
#line 374 "../src/computer-player.vala"
							if (a == 0) {
#line 375 "../src/computer-player.vala"
								a = 2;
#line 1642 "computer-player.c"
							}
#line 377 "../src/computer-player.vala"
							_tmp9_ = game_get_current_color (g);
#line 377 "../src/computer-player.vala"
							_tmp10_ = _tmp9_;
#line 377 "../src/computer-player.vala"
							if (game_get_owner (g, (guint8) x, (guint8) y) == _tmp10_) {
#line 377 "../src/computer-player.vala"
								_tmp8_ = a;
#line 1652 "computer-player.c"
							} else {
#line 377 "../src/computer-player.vala"
								_tmp8_ = -a;
#line 1656 "computer-player.c"
							}
#line 377 "../src/computer-player.vala"
							count = count + _tmp8_;
#line 1660 "computer-player.c"
						}
					}
				}
			}
		}
	}
#line 380 "../src/computer-player.vala"
	result = count;
#line 380 "../src/computer-player.vala"
	return result;
#line 1671 "computer-player.c"
}

static gint
computer_player_is_empty (Game* g,
                          gint8 x,
                          gint8 y)
{
	gint result = 0;
#line 383 "../src/computer-player.vala"
	g_return_val_if_fail (g != NULL, 0);
#line 385 "../src/computer-player.vala"
	if (!game_is_valid_location_signed (g, x, y)) {
#line 386 "../src/computer-player.vala"
		result = 0;
#line 386 "../src/computer-player.vala"
		return result;
#line 1688 "computer-player.c"
	}
#line 387 "../src/computer-player.vala"
	if (game_get_owner (g, (guint8) x, (guint8) y) != PLAYER_NONE) {
#line 388 "../src/computer-player.vala"
		result = 0;
#line 388 "../src/computer-player.vala"
		return result;
#line 1696 "computer-player.c"
	}
#line 390 "../src/computer-player.vala"
	result = 1;
#line 390 "../src/computer-player.vala"
	return result;
#line 1702 "computer-player.c"
}

static void
computer_player_random_select (Game* g,
                               guint8* move_x,
                               guint8* move_y)
{
	guint8 _vala_move_x = 0U;
	guint8 _vala_move_y = 0U;
	GList* moves = NULL;
	gint length = 0;
	GList* _tmp12_;
	guint8 i = 0U;
	guint8 xy = 0U;
	GList* _tmp13_;
	gconstpointer _tmp14_;
	guint8 _tmp15_;
	guint8 _tmp16_;
	guint8 _tmp17_;
	guint8 _tmp18_;
#line 397 "../src/computer-player.vala"
	g_return_if_fail (g != NULL);
#line 399 "../src/computer-player.vala"
	moves = NULL;
#line 1727 "computer-player.c"
	{
		guint8 x = 0U;
#line 400 "../src/computer-player.vala"
		x = (guint8) 0;
#line 1732 "computer-player.c"
		{
			gboolean _tmp0_ = FALSE;
#line 400 "../src/computer-player.vala"
			_tmp0_ = TRUE;
#line 400 "../src/computer-player.vala"
			while (TRUE) {
#line 1739 "computer-player.c"
				guint8 _tmp2_;
				guint8 _tmp3_;
#line 400 "../src/computer-player.vala"
				if (!_tmp0_) {
#line 1744 "computer-player.c"
					guint8 _tmp1_;
#line 400 "../src/computer-player.vala"
					_tmp1_ = x;
#line 400 "../src/computer-player.vala"
					x = _tmp1_ + 1;
#line 1750 "computer-player.c"
				}
#line 400 "../src/computer-player.vala"
				_tmp0_ = FALSE;
#line 400 "../src/computer-player.vala"
				_tmp2_ = game_get_size (g);
#line 400 "../src/computer-player.vala"
				_tmp3_ = _tmp2_;
#line 400 "../src/computer-player.vala"
				if (!(x < _tmp3_)) {
#line 400 "../src/computer-player.vala"
					break;
#line 1762 "computer-player.c"
				}
				{
					guint8 y = 0U;
#line 401 "../src/computer-player.vala"
					y = (guint8) 0;
#line 1768 "computer-player.c"
					{
						gboolean _tmp4_ = FALSE;
#line 401 "../src/computer-player.vala"
						_tmp4_ = TRUE;
#line 401 "../src/computer-player.vala"
						while (TRUE) {
#line 1775 "computer-player.c"
							guint8 _tmp6_;
							guint8 _tmp7_;
							Player _tmp8_;
							Player _tmp9_;
#line 401 "../src/computer-player.vala"
							if (!_tmp4_) {
#line 1782 "computer-player.c"
								guint8 _tmp5_;
#line 401 "../src/computer-player.vala"
								_tmp5_ = y;
#line 401 "../src/computer-player.vala"
								y = _tmp5_ + 1;
#line 1788 "computer-player.c"
							}
#line 401 "../src/computer-player.vala"
							_tmp4_ = FALSE;
#line 401 "../src/computer-player.vala"
							_tmp6_ = game_get_size (g);
#line 401 "../src/computer-player.vala"
							_tmp7_ = _tmp6_;
#line 401 "../src/computer-player.vala"
							if (!(y < _tmp7_)) {
#line 401 "../src/computer-player.vala"
								break;
#line 1800 "computer-player.c"
							}
#line 402 "../src/computer-player.vala"
							_tmp8_ = game_get_current_color (g);
#line 402 "../src/computer-player.vala"
							_tmp9_ = _tmp8_;
#line 402 "../src/computer-player.vala"
							if (game_can_place (g, x, y, _tmp9_)) {
#line 1808 "computer-player.c"
								guint8 _tmp10_;
								guint8 _tmp11_;
#line 403 "../src/computer-player.vala"
								_tmp10_ = game_get_size (g);
#line 403 "../src/computer-player.vala"
								_tmp11_ = _tmp10_;
#line 403 "../src/computer-player.vala"
								moves = g_list_append (moves, (gpointer) ((guintptr) ((x * _tmp11_) + y)));
#line 1817 "computer-player.c"
							}
						}
					}
				}
			}
		}
	}
#line 405 "../src/computer-player.vala"
	_tmp12_ = moves;
#line 405 "../src/computer-player.vala"
	length = (gint) g_list_length (_tmp12_);
#line 406 "../src/computer-player.vala"
	if (length == 0) {
#line 407 "../src/computer-player.vala"
		g_assert_not_reached ();
#line 1833 "computer-player.c"
	}
#line 409 "../src/computer-player.vala"
	i = (guint8) g_random_int_range ((gint32) 0, (gint32) length);
#line 410 "../src/computer-player.vala"
	_tmp13_ = moves;
#line 410 "../src/computer-player.vala"
	_tmp14_ = g_list_nth_data (_tmp13_, (guint) i);
#line 410 "../src/computer-player.vala"
	xy = (guint8) ((guintptr) _tmp14_);
#line 411 "../src/computer-player.vala"
	_tmp15_ = game_get_size (g);
#line 411 "../src/computer-player.vala"
	_tmp16_ = _tmp15_;
#line 411 "../src/computer-player.vala"
	_vala_move_x = xy / _tmp16_;
#line 412 "../src/computer-player.vala"
	_tmp17_ = game_get_size (g);
#line 412 "../src/computer-player.vala"
	_tmp18_ = _tmp17_;
#line 412 "../src/computer-player.vala"
	_vala_move_y = xy % _tmp18_;
#line 397 "../src/computer-player.vala"
	(moves == NULL) ? NULL : (moves = (g_list_free (moves), NULL));
#line 397 "../src/computer-player.vala"
	if (move_x) {
#line 397 "../src/computer-player.vala"
		*move_x = _vala_move_x;
#line 1861 "computer-player.c"
	}
#line 397 "../src/computer-player.vala"
	if (move_y) {
#line 397 "../src/computer-player.vala"
		*move_y = _vala_move_y;
#line 1867 "computer-player.c"
	}
}

static gboolean
computer_player_get_move_pending (ComputerPlayer* self)
{
	gboolean result;
	gboolean _result_ = FALSE;
#line 71 "../src/computer-player.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 73 "../src/computer-player.vala"
	g_rec_mutex_lock (&self->priv->_move_pending_mutex);
#line 74 "../src/computer-player.vala"
	_result_ = self->priv->_move_pending;
#line 75 "../src/computer-player.vala"
	g_rec_mutex_unlock (&self->priv->_move_pending_mutex);
#line 76 "../src/computer-player.vala"
	result = _result_;
#line 76 "../src/computer-player.vala"
	return result;
#line 1888 "computer-player.c"
}

static void
computer_player_set_move_pending (ComputerPlayer* self,
                                  gboolean value)
{
#line 79 "../src/computer-player.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/computer-player.vala"
	g_rec_mutex_lock (&self->priv->_move_pending_mutex);
#line 82 "../src/computer-player.vala"
	self->priv->_move_pending = value;
#line 83 "../src/computer-player.vala"
	g_rec_mutex_unlock (&self->priv->_move_pending_mutex);
#line 1903 "computer-player.c"
}

static void
computer_player_possible_move_init (ComputerPlayerPossibleMove *self,
                                    guint8 x,
                                    guint8 y,
                                    guint8 n_tiles)
{
#line 31 "../src/computer-player.vala"
	memset (self, 0, sizeof (ComputerPlayerPossibleMove));
#line 33 "../src/computer-player.vala"
	(*self).x = x;
#line 34 "../src/computer-player.vala"
	(*self).y = y;
#line 35 "../src/computer-player.vala"
	(*self).n_tiles = n_tiles;
#line 1920 "computer-player.c"
}

static ComputerPlayerPossibleMove*
computer_player_possible_move_dup (const ComputerPlayerPossibleMove* self)
{
	ComputerPlayerPossibleMove* dup;
#line 25 "../src/computer-player.vala"
	dup = g_new0 (ComputerPlayerPossibleMove, 1);
#line 25 "../src/computer-player.vala"
	memcpy (dup, self, sizeof (ComputerPlayerPossibleMove));
#line 25 "../src/computer-player.vala"
	return dup;
#line 1933 "computer-player.c"
}

static void
computer_player_possible_move_free (ComputerPlayerPossibleMove* self)
{
#line 25 "../src/computer-player.vala"
	g_free (self);
#line 1941 "computer-player.c"
}

static GType
computer_player_possible_move_get_type (void)
{
	static volatile gsize computer_player_possible_move_type_id__volatile = 0;
	if (g_once_init_enter (&computer_player_possible_move_type_id__volatile)) {
		GType computer_player_possible_move_type_id;
		computer_player_possible_move_type_id = g_boxed_type_register_static ("ComputerPlayerPossibleMove", (GBoxedCopyFunc) computer_player_possible_move_dup, (GBoxedFreeFunc) computer_player_possible_move_free);
		g_once_init_leave (&computer_player_possible_move_type_id__volatile, computer_player_possible_move_type_id);
	}
	return computer_player_possible_move_type_id__volatile;
}

static void
computer_player_class_init (ComputerPlayerClass * klass,
                            gpointer klass_data)
{
#line 23 "../src/computer-player.vala"
	computer_player_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/computer-player.vala"
	g_type_class_adjust_private_offset (klass, &ComputerPlayer_private_offset);
#line 23 "../src/computer-player.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_computer_player_get_property;
#line 23 "../src/computer-player.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_computer_player_set_property;
#line 23 "../src/computer-player.vala"
	G_OBJECT_CLASS (klass)->finalize = computer_player_finalize;
#line 1970 "computer-player.c"
}

static void
computer_player_instance_init (ComputerPlayer * self,
                               gpointer klass)
{
#line 23 "../src/computer-player.vala"
	self->priv = computer_player_get_instance_private (self);
#line 63 "../src/computer-player.vala"
	self->priv->pending_move_id = (guint) 0;
#line 67 "../src/computer-player.vala"
	self->priv->_move_pending = FALSE;
#line 1983 "computer-player.c"
}

static void
computer_player_finalize (GObject * obj)
{
	ComputerPlayer * self;
#line 23 "../src/computer-player.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMPUTER_PLAYER, ComputerPlayer);
#line 44 "../src/computer-player.vala"
	_g_object_unref0 (self->priv->game);
#line 68 "../src/computer-player.vala"
	_vala_clear_GRecMutex (&self->priv->_move_pending_mutex);
#line 23 "../src/computer-player.vala"
	G_OBJECT_CLASS (computer_player_parent_class)->finalize (obj);
#line 1998 "computer-player.c"
}

GType
computer_player_get_type (void)
{
	static volatile gsize computer_player_type_id__volatile = 0;
	if (g_once_init_enter (&computer_player_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ComputerPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) computer_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ComputerPlayer), 0, (GInstanceInitFunc) computer_player_instance_init, NULL };
		GType computer_player_type_id;
		computer_player_type_id = g_type_register_static (G_TYPE_OBJECT, "ComputerPlayer", &g_define_type_info, 0);
		ComputerPlayer_private_offset = g_type_add_instance_private (computer_player_type_id, sizeof (ComputerPlayerPrivate));
		g_once_init_leave (&computer_player_type_id__volatile, computer_player_type_id);
	}
	return computer_player_type_id__volatile;
}

static void
_vala_computer_player_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	ComputerPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COMPUTER_PLAYER, ComputerPlayer);
#line 23 "../src/computer-player.vala"
	switch (property_id) {
#line 2025 "computer-player.c"
		default:
#line 23 "../src/computer-player.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/computer-player.vala"
		break;
#line 2031 "computer-player.c"
	}
}

static void
_vala_computer_player_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	ComputerPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COMPUTER_PLAYER, ComputerPlayer);
#line 23 "../src/computer-player.vala"
	switch (property_id) {
#line 2045 "computer-player.c"
		default:
#line 23 "../src/computer-player.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/computer-player.vala"
		break;
#line 2051 "computer-player.c"
	}
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

