/* game.c generated by valac 0.44.0, the Vala compiler
 * generated from game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2010-2013 Robert Ancell
   Copyright 2013-2014 Michael Catanzaro
   Copyright 2014-2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;
typedef enum  {
	PLAYER_NONE,
	PLAYER_DARK,
	PLAYER_LIGHT
} Player;

#define TYPE_PLAYER (player_get_type ())
enum  {
	GAME_0_PROPERTY,
	GAME_SIZE_PROPERTY,
	GAME_CURRENT_COLOR_PROPERTY,
	GAME_NUMBER_OF_MOVES_PROPERTY,
	GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY,
	GAME_IS_COMPLETE_PROPERTY,
	GAME_INITIAL_NUMBER_OF_TILES_PROPERTY,
	GAME_N_TILES_PROPERTY,
	GAME_N_LIGHT_TILES_PROPERTY,
	GAME_N_DARK_TILES_PROPERTY,
	GAME_N_CURRENT_TILES_PROPERTY,
	GAME_N_OPPONENT_TILES_PROPERTY,
	GAME_ALTERNATIVE_START_PROPERTY,
	GAME_NUM_PROPERTIES
};
static GParamSpec* game_properties[GAME_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	GAME_TURN_ENDED_SIGNAL,
	GAME_SQUARE_CHANGED_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GamePrivate {
	Player* tiles;
	gint tiles_length1;
	gint tiles_length2;
	guint8 _size;
	guint8** undo_stack;
	gint undo_stack_length1;
	gint _undo_stack_size_;
	gint history_index;
	Player _current_color;
	guint8 _number_of_moves;
	gboolean _current_player_can_move;
	gboolean _is_complete;
	guint8 _initial_number_of_tiles;
	guint8 _n_light_tiles;
	guint8 _n_dark_tiles;
	gboolean _alternative_start;
};

static gint Game_private_offset;
static gpointer game_parent_class = NULL;

GType game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
GType player_get_type (void) G_GNUC_CONST;
Game* game_new (gboolean alternative_start,
                guint8 _size);
Game* game_construct (GType object_type,
                      gboolean alternative_start,
                      guint8 _size);
static void game_init_undo_stack (guint8 size,
                           guint8*** undo_stack,
                           gint* undo_stack_length1);
static void game_set_initial_number_of_tiles (Game* self,
                                       guint8 value);
static void game_set_n_current_tiles (Game* self,
                               guint8 value);
static void game_set_n_opponent_tiles (Game* self,
                                guint8 value);
Game* game_new_from_strings (gchar** setup,
                             gint setup_length1,
                             Player to_move,
                             guint8 _size);
Game* game_construct_from_strings (GType object_type,
                                   gchar** setup,
                                   gint setup_length1,
                                   Player to_move,
                                   guint8 _size);
Player player_from_char (gchar c);
static void game_set_current_color (Game* self,
                             Player value);
gchar* game_to_string (Game* self);
guint8 game_get_size (Game* self);
gchar* player_to_string (Player self);
Game* game_new_copy (Game* game);
Game* game_construct_copy (GType object_type,
                           Game* game);
guint8 game_get_number_of_moves (Game* self);
static void game_set_number_of_moves (Game* self,
                               guint8 value);
Player game_get_current_color (Game* self);
guint8 game_get_n_current_tiles (Game* self);
guint8 game_get_n_opponent_tiles (Game* self);
gboolean game_is_valid_location_signed (Game* self,
                                        gint8 x,
                                        gint8 y);
gboolean game_is_valid_location_unsigned (Game* self,
                                          guint8 x,
                                          guint8 y);
Player game_get_owner (Game* self,
                       guint8 x,
                       guint8 y);
gboolean game_can_place (Game* self,
                         guint8 x,
                         guint8 y,
                         Player color);
static guint8 game_can_flip_tiles (Game* self,
                            guint8 x,
                            guint8 y,
                            gint8 x_step,
                            gint8 y_step,
                            Player color);
guint8 game_place_tile (Game* self,
                        guint8 x,
                        guint8 y,
                        gboolean apply);
static guint8 game_flip_tiles (Game* self,
                        guint8 x,
                        guint8 y,
                        gint8 x_step,
                        gint8 y_step,
                        gboolean apply);
static void game_set_tile (Game* self,
                    guint8 x,
                    guint8 y);
static void game_end_of_turn (Game* self);
void game_pass (Game* self);
gboolean game_get_current_player_can_move (Game* self);
Player player_flip_color (Player p);
static void game_update_who_can_move (Game* self);
static void game_set_current_player_can_move (Game* self,
                                       gboolean value);
static void game_set_is_complete (Game* self,
                           gboolean value);
static guint8* _uint8_dup (guint8* self);
void game_undo (Game* self,
                guint8 count);
static void game_unset_tile (Game* self,
                      guint8 tile_number,
                      Player replacement_color);
static void game_set_size (Game* self,
                    guint8 value);
gboolean game_get_is_complete (Game* self);
guint8 game_get_initial_number_of_tiles (Game* self);
guint8 game_get_n_tiles (Game* self);
guint8 game_get_n_dark_tiles (Game* self);
guint8 game_get_n_light_tiles (Game* self);
gboolean game_get_alternative_start (Game* self);
static void game_set_alternative_start (Game* self,
                                 gboolean value);
static void g_cclosure_user_marshal_VOID__UCHAR_UCHAR_ENUM (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data);
static GObject * game_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties);
static void game_finalize (GObject * obj);
static void _vala_game_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_game_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
game_get_instance_private (Game* self)
{
	return G_STRUCT_MEMBER_P (self, Game_private_offset);
}

Game*
game_construct (GType object_type,
                gboolean alternative_start,
                guint8 _size)
{
	Game * self = NULL;
	guint8** _tmp5_ = NULL;
	gint _tmp6_ = 0;
#line 103 "../src/game.vala"
	_vala_return_val_if_fail (((gint) _size) >= 4, "_size >= 4", NULL);
#line 103 "../src/game.vala"
	_vala_return_val_if_fail (((gint) _size) <= 16, "_size <= 16", NULL);
#line 107 "../src/game.vala"
	self = (Game*) g_object_new (object_type, "alternative-start", alternative_start, "size", _size, NULL);
#line 252 "game.c"
	{
		guint8 x = 0U;
#line 109 "../src/game.vala"
		x = (guint8) 0;
#line 257 "game.c"
		{
			gboolean _tmp0_ = FALSE;
#line 109 "../src/game.vala"
			_tmp0_ = TRUE;
#line 109 "../src/game.vala"
			while (TRUE) {
#line 109 "../src/game.vala"
				if (!_tmp0_) {
#line 266 "game.c"
					guint8 _tmp1_;
#line 109 "../src/game.vala"
					_tmp1_ = x;
#line 109 "../src/game.vala"
					x = _tmp1_ + 1;
#line 272 "game.c"
				}
#line 109 "../src/game.vala"
				_tmp0_ = FALSE;
#line 109 "../src/game.vala"
				if (!(x < _size)) {
#line 109 "../src/game.vala"
					break;
#line 280 "game.c"
				}
				{
					guint8 y = 0U;
#line 110 "../src/game.vala"
					y = (guint8) 0;
#line 286 "game.c"
					{
						gboolean _tmp2_ = FALSE;
#line 110 "../src/game.vala"
						_tmp2_ = TRUE;
#line 110 "../src/game.vala"
						while (TRUE) {
#line 293 "game.c"
							Player* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
#line 110 "../src/game.vala"
							if (!_tmp2_) {
#line 299 "game.c"
								guint8 _tmp3_;
#line 110 "../src/game.vala"
								_tmp3_ = y;
#line 110 "../src/game.vala"
								y = _tmp3_ + 1;
#line 305 "game.c"
							}
#line 110 "../src/game.vala"
							_tmp2_ = FALSE;
#line 110 "../src/game.vala"
							if (!(y < _size)) {
#line 110 "../src/game.vala"
								break;
#line 313 "game.c"
							}
#line 111 "../src/game.vala"
							_tmp4_ = self->priv->tiles;
#line 111 "../src/game.vala"
							_tmp4__length1 = self->priv->tiles_length1;
#line 111 "../src/game.vala"
							_tmp4__length2 = self->priv->tiles_length2;
#line 111 "../src/game.vala"
							_tmp4_[(x * _tmp4__length2) + y] = PLAYER_NONE;
#line 323 "game.c"
						}
					}
				}
			}
		}
	}
#line 113 "../src/game.vala"
	game_init_undo_stack (_size, &_tmp5_, &_tmp6_);
#line 113 "../src/game.vala"
	self->priv->undo_stack = (_vala_array_free (self->priv->undo_stack, self->priv->undo_stack_length1, (GDestroyNotify) g_free), NULL);
#line 113 "../src/game.vala"
	self->priv->undo_stack = _tmp5_;
#line 113 "../src/game.vala"
	self->priv->undo_stack_length1 = _tmp6_;
#line 113 "../src/game.vala"
	self->priv->_undo_stack_size_ = self->priv->undo_stack_length1;
#line 115 "../src/game.vala"
	if ((_size % 2) == 0) {
#line 342 "game.c"
		Player _tmp7_ = 0;
		Player* _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		Player* _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		Player _tmp10_ = 0;
		Player* _tmp11_;
		gint _tmp11__length1;
		gint _tmp11__length2;
		Player* _tmp12_;
		gint _tmp12__length1;
		gint _tmp12__length2;
#line 118 "../src/game.vala"
		game_set_initial_number_of_tiles (self, (guint8) 4);
#line 119 "../src/game.vala"
		if (alternative_start) {
#line 119 "../src/game.vala"
			_tmp7_ = PLAYER_DARK;
#line 363 "game.c"
		} else {
#line 119 "../src/game.vala"
			_tmp7_ = PLAYER_LIGHT;
#line 367 "game.c"
		}
#line 119 "../src/game.vala"
		_tmp8_ = self->priv->tiles;
#line 119 "../src/game.vala"
		_tmp8__length1 = self->priv->tiles_length1;
#line 119 "../src/game.vala"
		_tmp8__length2 = self->priv->tiles_length2;
#line 119 "../src/game.vala"
		_tmp8_[(((_size / 2) - 1) * _tmp8__length2) + ((_size / 2) - 1)] = _tmp7_;
#line 120 "../src/game.vala"
		_tmp9_ = self->priv->tiles;
#line 120 "../src/game.vala"
		_tmp9__length1 = self->priv->tiles_length1;
#line 120 "../src/game.vala"
		_tmp9__length2 = self->priv->tiles_length2;
#line 120 "../src/game.vala"
		_tmp9_[(((_size / 2) - 1) * _tmp9__length2) + (_size / 2)] = PLAYER_DARK;
#line 121 "../src/game.vala"
		if (alternative_start) {
#line 121 "../src/game.vala"
			_tmp10_ = PLAYER_LIGHT;
#line 389 "game.c"
		} else {
#line 121 "../src/game.vala"
			_tmp10_ = PLAYER_DARK;
#line 393 "game.c"
		}
#line 121 "../src/game.vala"
		_tmp11_ = self->priv->tiles;
#line 121 "../src/game.vala"
		_tmp11__length1 = self->priv->tiles_length1;
#line 121 "../src/game.vala"
		_tmp11__length2 = self->priv->tiles_length2;
#line 121 "../src/game.vala"
		_tmp11_[((_size / 2) * _tmp11__length2) + ((_size / 2) - 1)] = _tmp10_;
#line 122 "../src/game.vala"
		_tmp12_ = self->priv->tiles;
#line 122 "../src/game.vala"
		_tmp12__length1 = self->priv->tiles_length1;
#line 122 "../src/game.vala"
		_tmp12__length2 = self->priv->tiles_length2;
#line 122 "../src/game.vala"
		_tmp12_[((_size / 2) * _tmp12__length2) + (_size / 2)] = PLAYER_LIGHT;
#line 123 "../src/game.vala"
		game_set_n_current_tiles (self, (guint8) 2);
#line 124 "../src/game.vala"
		game_set_n_opponent_tiles (self, (guint8) 2);
#line 415 "game.c"
	} else {
		Player* _tmp13_;
		gint _tmp13__length1;
		gint _tmp13__length2;
		Player _tmp14_ = 0;
		Player* _tmp15_;
		gint _tmp15__length1;
		gint _tmp15__length2;
		Player _tmp16_ = 0;
		Player* _tmp17_;
		gint _tmp17__length1;
		gint _tmp17__length2;
		Player* _tmp18_;
		gint _tmp18__length1;
		gint _tmp18__length2;
		Player _tmp19_ = 0;
		Player* _tmp20_;
		gint _tmp20__length1;
		gint _tmp20__length2;
		Player _tmp21_ = 0;
		Player* _tmp22_;
		gint _tmp22__length1;
		gint _tmp22__length2;
		Player* _tmp23_;
		gint _tmp23__length1;
		gint _tmp23__length2;
#line 129 "../src/game.vala"
		game_set_initial_number_of_tiles (self, (guint8) 7);
#line 130 "../src/game.vala"
		_tmp13_ = self->priv->tiles;
#line 130 "../src/game.vala"
		_tmp13__length1 = self->priv->tiles_length1;
#line 130 "../src/game.vala"
		_tmp13__length2 = self->priv->tiles_length2;
#line 130 "../src/game.vala"
		_tmp13_[(((_size - 1) / 2) * _tmp13__length2) + ((_size - 1) / 2)] = PLAYER_DARK;
#line 131 "../src/game.vala"
		if (alternative_start) {
#line 131 "../src/game.vala"
			_tmp14_ = PLAYER_LIGHT;
#line 456 "game.c"
		} else {
#line 131 "../src/game.vala"
			_tmp14_ = PLAYER_DARK;
#line 460 "game.c"
		}
#line 131 "../src/game.vala"
		_tmp15_ = self->priv->tiles;
#line 131 "../src/game.vala"
		_tmp15__length1 = self->priv->tiles_length1;
#line 131 "../src/game.vala"
		_tmp15__length2 = self->priv->tiles_length2;
#line 131 "../src/game.vala"
		_tmp15_[(((_size + 1) / 2) * _tmp15__length2) + ((_size - 3) / 2)] = _tmp14_;
#line 132 "../src/game.vala"
		if (alternative_start) {
#line 132 "../src/game.vala"
			_tmp16_ = PLAYER_LIGHT;
#line 474 "game.c"
		} else {
#line 132 "../src/game.vala"
			_tmp16_ = PLAYER_DARK;
#line 478 "game.c"
		}
#line 132 "../src/game.vala"
		_tmp17_ = self->priv->tiles;
#line 132 "../src/game.vala"
		_tmp17__length1 = self->priv->tiles_length1;
#line 132 "../src/game.vala"
		_tmp17__length2 = self->priv->tiles_length2;
#line 132 "../src/game.vala"
		_tmp17_[(((_size - 3) / 2) * _tmp17__length2) + ((_size + 1) / 2)] = _tmp16_;
#line 133 "../src/game.vala"
		_tmp18_ = self->priv->tiles;
#line 133 "../src/game.vala"
		_tmp18__length1 = self->priv->tiles_length1;
#line 133 "../src/game.vala"
		_tmp18__length2 = self->priv->tiles_length2;
#line 133 "../src/game.vala"
		_tmp18_[(((_size - 1) / 2) * _tmp18__length2) + ((_size - 3) / 2)] = PLAYER_LIGHT;
#line 134 "../src/game.vala"
		if (alternative_start) {
#line 134 "../src/game.vala"
			_tmp19_ = PLAYER_DARK;
#line 500 "game.c"
		} else {
#line 134 "../src/game.vala"
			_tmp19_ = PLAYER_LIGHT;
#line 504 "game.c"
		}
#line 134 "../src/game.vala"
		_tmp20_ = self->priv->tiles;
#line 134 "../src/game.vala"
		_tmp20__length1 = self->priv->tiles_length1;
#line 134 "../src/game.vala"
		_tmp20__length2 = self->priv->tiles_length2;
#line 134 "../src/game.vala"
		_tmp20_[(((_size - 3) / 2) * _tmp20__length2) + ((_size - 1) / 2)] = _tmp19_;
#line 135 "../src/game.vala"
		if (alternative_start) {
#line 135 "../src/game.vala"
			_tmp21_ = PLAYER_DARK;
#line 518 "game.c"
		} else {
#line 135 "../src/game.vala"
			_tmp21_ = PLAYER_LIGHT;
#line 522 "game.c"
		}
#line 135 "../src/game.vala"
		_tmp22_ = self->priv->tiles;
#line 135 "../src/game.vala"
		_tmp22__length1 = self->priv->tiles_length1;
#line 135 "../src/game.vala"
		_tmp22__length2 = self->priv->tiles_length2;
#line 135 "../src/game.vala"
		_tmp22_[(((_size + 1) / 2) * _tmp22__length2) + ((_size - 1) / 2)] = _tmp21_;
#line 136 "../src/game.vala"
		_tmp23_ = self->priv->tiles;
#line 136 "../src/game.vala"
		_tmp23__length1 = self->priv->tiles_length1;
#line 136 "../src/game.vala"
		_tmp23__length2 = self->priv->tiles_length2;
#line 136 "../src/game.vala"
		_tmp23_[(((_size - 1) / 2) * _tmp23__length2) + ((_size + 1) / 2)] = PLAYER_LIGHT;
#line 137 "../src/game.vala"
		game_set_n_current_tiles (self, (guint8) 3);
#line 138 "../src/game.vala"
		game_set_n_opponent_tiles (self, (guint8) 4);
#line 544 "game.c"
	}
#line 103 "../src/game.vala"
	return self;
#line 548 "game.c"
}

Game*
game_new (gboolean alternative_start,
          guint8 _size)
{
#line 103 "../src/game.vala"
	return game_construct (TYPE_GAME, alternative_start, _size);
#line 557 "game.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 574 "game.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
#line 1148 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1149 "glib-2.0.vapi"
		separator = "";
#line 588 "game.c"
	}
#line 1151 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 592 "game.c"
		gboolean _tmp1_ = FALSE;
#line 1151 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1151 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 598 "game.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1151 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 603 "game.c"
				const gchar* _tmp3_;
#line 1151 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1151 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 609 "game.c"
			} else {
#line 1151 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 613 "game.c"
			}
#line 1151 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 617 "game.c"
		}
#line 1151 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 621 "game.c"
	} else {
#line 1151 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 625 "game.c"
	}
#line 1151 "glib-2.0.vapi"
	if (_tmp0_) {
#line 629 "game.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		void* ptr = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		void* _tmp21_;
		const gchar* _tmp31_;
#line 1153 "glib-2.0.vapi"
		len = (gsize) 1;
#line 643 "game.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
			i = 0;
#line 1154 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1154 "glib-2.0.vapi"
			while (TRUE) {
#line 652 "game.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1154 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 659 "game.c"
					gint _tmp5_;
#line 1154 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1154 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 665 "game.c"
				}
#line 1154 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 673 "game.c"
				} else {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 677 "game.c"
				}
#line 1154 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1154 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 683 "game.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1154 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 688 "game.c"
						const gchar* _tmp9_;
#line 1154 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1154 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 694 "game.c"
					} else {
#line 1154 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 698 "game.c"
					}
#line 1154 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 702 "game.c"
				}
#line 1154 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1154 "glib-2.0.vapi"
					break;
#line 708 "game.c"
				}
#line 1155 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1155 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 714 "game.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1155 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1155 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1155 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1155 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 726 "game.c"
				} else {
#line 1155 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 730 "game.c"
				}
#line 1155 "glib-2.0.vapi"
				len = len + _tmp10_;
#line 734 "game.c"
			}
		}
#line 1157 "glib-2.0.vapi"
		if (i == 0) {
#line 739 "game.c"
			gchar* _tmp15_;
#line 1158 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1158 "glib-2.0.vapi"
			result = _tmp15_;
#line 1158 "glib-2.0.vapi"
			return result;
#line 747 "game.c"
		}
#line 1160 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1161 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1161 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1161 "glib-2.0.vapi"
		len = len + (_tmp17_ * (i - 1));
#line 1163 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1163 "glib-2.0.vapi"
		res = _tmp18_;
#line 1164 "glib-2.0.vapi"
		_tmp19_ = res;
#line 1164 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1164 "glib-2.0.vapi"
		_tmp21_ = g_stpcpy ((void*) _tmp19_, (const gchar*) _tmp20_);
#line 1164 "glib-2.0.vapi"
		ptr = _tmp21_;
#line 769 "game.c"
		{
			gboolean _tmp22_ = FALSE;
#line 1165 "glib-2.0.vapi"
			i = 1;
#line 1165 "glib-2.0.vapi"
			_tmp22_ = TRUE;
#line 1165 "glib-2.0.vapi"
			while (TRUE) {
#line 778 "game.c"
				void* _tmp24_;
				void* _tmp25_;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp27_;
				void* _tmp29_;
				void* _tmp30_;
#line 1165 "glib-2.0.vapi"
				if (!_tmp22_) {
#line 787 "game.c"
					gint _tmp23_;
#line 1165 "glib-2.0.vapi"
					_tmp23_ = i;
#line 1165 "glib-2.0.vapi"
					i = _tmp23_ + 1;
#line 793 "game.c"
				}
#line 1165 "glib-2.0.vapi"
				_tmp22_ = FALSE;
#line 1165 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1165 "glib-2.0.vapi"
					break;
#line 801 "game.c"
				}
#line 1166 "glib-2.0.vapi"
				_tmp24_ = ptr;
#line 1166 "glib-2.0.vapi"
				_tmp25_ = g_stpcpy (_tmp24_, (const gchar*) separator);
#line 1166 "glib-2.0.vapi"
				ptr = _tmp25_;
#line 1167 "glib-2.0.vapi"
				_tmp27_ = str_array[i];
#line 1167 "glib-2.0.vapi"
				if (_tmp27_ != NULL) {
#line 813 "game.c"
					const gchar* _tmp28_;
#line 1167 "glib-2.0.vapi"
					_tmp28_ = str_array[i];
#line 1167 "glib-2.0.vapi"
					_tmp26_ = (const gchar*) _tmp28_;
#line 819 "game.c"
				} else {
#line 1167 "glib-2.0.vapi"
					_tmp26_ = "";
#line 823 "game.c"
				}
#line 1167 "glib-2.0.vapi"
				_tmp29_ = ptr;
#line 1167 "glib-2.0.vapi"
				_tmp30_ = g_stpcpy (_tmp29_, _tmp26_);
#line 1167 "glib-2.0.vapi"
				ptr = _tmp30_;
#line 831 "game.c"
			}
		}
#line 1170 "glib-2.0.vapi"
		_tmp31_ = res;
#line 1170 "glib-2.0.vapi"
		res = NULL;
#line 1170 "glib-2.0.vapi"
		result = (gchar*) _tmp31_;
#line 1170 "glib-2.0.vapi"
		return result;
#line 842 "game.c"
	} else {
		gchar* _tmp32_;
#line 1172 "glib-2.0.vapi"
		_tmp32_ = g_strdup ("");
#line 1172 "glib-2.0.vapi"
		result = _tmp32_;
#line 1172 "glib-2.0.vapi"
		return result;
#line 851 "game.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 876 "game.c"
}

Game*
game_construct_from_strings (GType object_type,
                             gchar** setup,
                             gint setup_length1,
                             Player to_move,
                             guint8 _size)
{
	Game * self = NULL;
	guint8** _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
#line 142 "../src/game.vala"
	_vala_return_val_if_fail (((gint) _size) >= 4, "_size >= 4", NULL);
#line 142 "../src/game.vala"
	_vala_return_val_if_fail (((gint) _size) <= 16, "_size <= 16", NULL);
#line 142 "../src/game.vala"
	_vala_return_val_if_fail (to_move != PLAYER_NONE, "to_move != Player.NONE", NULL);
#line 142 "../src/game.vala"
	_vala_return_val_if_fail (setup_length1 == ((gint) _size), "setup.length == _size", NULL);
#line 148 "../src/game.vala"
	self = (Game*) g_object_new (object_type, "size", _size, NULL);
#line 150 "../src/game.vala"
	game_init_undo_stack (_size, &_tmp0_, &_tmp1_);
#line 150 "../src/game.vala"
	self->priv->undo_stack = (_vala_array_free (self->priv->undo_stack, self->priv->undo_stack_length1, (GDestroyNotify) g_free), NULL);
#line 150 "../src/game.vala"
	self->priv->undo_stack = _tmp0_;
#line 150 "../src/game.vala"
	self->priv->undo_stack_length1 = _tmp1_;
#line 150 "../src/game.vala"
	self->priv->_undo_stack_size_ = self->priv->undo_stack_length1;
#line 917 "game.c"
	{
		guint8 y = 0U;
#line 152 "../src/game.vala"
		y = (guint8) 0;
#line 922 "game.c"
		{
			gboolean _tmp2_ = FALSE;
#line 152 "../src/game.vala"
			_tmp2_ = TRUE;
#line 152 "../src/game.vala"
			while (TRUE) {
#line 929 "game.c"
				const gchar* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 152 "../src/game.vala"
				if (!_tmp2_) {
#line 935 "game.c"
					guint8 _tmp3_;
#line 152 "../src/game.vala"
					_tmp3_ = y;
#line 152 "../src/game.vala"
					y = _tmp3_ + 1;
#line 941 "game.c"
				}
#line 152 "../src/game.vala"
				_tmp2_ = FALSE;
#line 152 "../src/game.vala"
				if (!(y < _size)) {
#line 152 "../src/game.vala"
					break;
#line 949 "game.c"
				}
#line 154 "../src/game.vala"
				_tmp4_ = setup[y];
#line 154 "../src/game.vala"
				_tmp5_ = strlen (_tmp4_);
#line 154 "../src/game.vala"
				_tmp6_ = _tmp5_;
#line 154 "../src/game.vala"
				if (_tmp6_ != (_size * 2)) {
#line 155 "../src/game.vala"
					g_warn_if_reached ();
#line 961 "game.c"
				}
				{
					guint8 x = 0U;
#line 156 "../src/game.vala"
					x = (guint8) 0;
#line 967 "game.c"
					{
						gboolean _tmp7_ = FALSE;
#line 156 "../src/game.vala"
						_tmp7_ = TRUE;
#line 156 "../src/game.vala"
						while (TRUE) {
#line 974 "game.c"
							Player* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
							const gchar* _tmp10_;
#line 156 "../src/game.vala"
							if (!_tmp7_) {
#line 981 "game.c"
								guint8 _tmp8_;
#line 156 "../src/game.vala"
								_tmp8_ = x;
#line 156 "../src/game.vala"
								x = _tmp8_ + 1;
#line 987 "game.c"
							}
#line 156 "../src/game.vala"
							_tmp7_ = FALSE;
#line 156 "../src/game.vala"
							if (!(x < _size)) {
#line 156 "../src/game.vala"
								break;
#line 995 "game.c"
							}
#line 157 "../src/game.vala"
							_tmp9_ = self->priv->tiles;
#line 157 "../src/game.vala"
							_tmp9__length1 = self->priv->tiles_length1;
#line 157 "../src/game.vala"
							_tmp9__length2 = self->priv->tiles_length2;
#line 157 "../src/game.vala"
							_tmp10_ = setup[y];
#line 157 "../src/game.vala"
							_tmp9_[(x * _tmp9__length2) + y] = player_from_char (string_get (_tmp10_, (glong) ((x * 2) + 1)));
#line 1007 "game.c"
						}
					}
				}
			}
		}
	}
#line 160 "../src/game.vala"
	game_set_current_color (self, to_move);
#line 162 "../src/game.vala"
	_tmp11_ = _vala_g_strjoinv ("\n", (gchar**) setup, (gint) ((setup_length1 * sizeof (gchar*)) / sizeof (gchar*)));
#line 162 "../src/game.vala"
	_tmp12_ = _tmp11_;
#line 162 "../src/game.vala"
	_tmp13_ = string_strip (_tmp12_);
#line 162 "../src/game.vala"
	_tmp14_ = _tmp13_;
#line 162 "../src/game.vala"
	_tmp15_ = game_to_string (self);
#line 162 "../src/game.vala"
	_tmp16_ = _tmp15_;
#line 162 "../src/game.vala"
	_tmp17_ = string_strip (_tmp16_);
#line 162 "../src/game.vala"
	_tmp18_ = _tmp17_;
#line 162 "../src/game.vala"
	g_warn_if_fail (g_strcmp0 (_tmp14_, _tmp18_) == 0);
#line 162 "../src/game.vala"
	_g_free0 (_tmp18_);
#line 162 "../src/game.vala"
	_g_free0 (_tmp16_);
#line 162 "../src/game.vala"
	_g_free0 (_tmp14_);
#line 162 "../src/game.vala"
	_g_free0 (_tmp12_);
#line 142 "../src/game.vala"
	return self;
#line 1044 "game.c"
}

Game*
game_new_from_strings (gchar** setup,
                       gint setup_length1,
                       Player to_move,
                       guint8 _size)
{
#line 142 "../src/game.vala"
	return game_construct_from_strings (TYPE_GAME, setup, setup_length1, to_move, _size);
#line 1055 "game.c"
}

gchar*
game_to_string (Game* self)
{
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
#line 165 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 167 "../src/game.vala"
	_tmp0_ = g_strdup ("\n");
#line 167 "../src/game.vala"
	s = _tmp0_;
#line 1070 "game.c"
	{
		guint8 y = 0U;
#line 169 "../src/game.vala"
		y = (guint8) 0;
#line 1075 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 169 "../src/game.vala"
			_tmp1_ = TRUE;
#line 169 "../src/game.vala"
			while (TRUE) {
#line 1082 "game.c"
				guint8 _tmp3_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
#line 169 "../src/game.vala"
				if (!_tmp1_) {
#line 1088 "game.c"
					guint8 _tmp2_;
#line 169 "../src/game.vala"
					_tmp2_ = y;
#line 169 "../src/game.vala"
					y = _tmp2_ + 1;
#line 1094 "game.c"
				}
#line 169 "../src/game.vala"
				_tmp1_ = FALSE;
#line 169 "../src/game.vala"
				_tmp3_ = self->priv->_size;
#line 169 "../src/game.vala"
				if (!(y < _tmp3_)) {
#line 169 "../src/game.vala"
					break;
#line 1104 "game.c"
				}
				{
					guint8 x = 0U;
#line 171 "../src/game.vala"
					x = (guint8) 0;
#line 1110 "game.c"
					{
						gboolean _tmp4_ = FALSE;
#line 171 "../src/game.vala"
						_tmp4_ = TRUE;
#line 171 "../src/game.vala"
						while (TRUE) {
#line 1117 "game.c"
							guint8 _tmp6_;
							const gchar* _tmp7_;
							Player* _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							Player _tmp9_;
							gchar* _tmp10_;
							gchar* _tmp11_;
							gchar* _tmp12_;
							gchar* _tmp13_;
							gchar* _tmp14_;
#line 171 "../src/game.vala"
							if (!_tmp4_) {
#line 1131 "game.c"
								guint8 _tmp5_;
#line 171 "../src/game.vala"
								_tmp5_ = x;
#line 171 "../src/game.vala"
								x = _tmp5_ + 1;
#line 1137 "game.c"
							}
#line 171 "../src/game.vala"
							_tmp4_ = FALSE;
#line 171 "../src/game.vala"
							_tmp6_ = self->priv->_size;
#line 171 "../src/game.vala"
							if (!(x < _tmp6_)) {
#line 171 "../src/game.vala"
								break;
#line 1147 "game.c"
							}
#line 172 "../src/game.vala"
							_tmp7_ = s;
#line 172 "../src/game.vala"
							_tmp8_ = self->priv->tiles;
#line 172 "../src/game.vala"
							_tmp8__length1 = self->priv->tiles_length1;
#line 172 "../src/game.vala"
							_tmp8__length2 = self->priv->tiles_length2;
#line 172 "../src/game.vala"
							_tmp9_ = _tmp8_[(x * _tmp8__length2) + y];
#line 172 "../src/game.vala"
							_tmp10_ = player_to_string (_tmp9_);
#line 172 "../src/game.vala"
							_tmp11_ = _tmp10_;
#line 172 "../src/game.vala"
							_tmp12_ = g_strconcat (" ", _tmp11_, NULL);
#line 172 "../src/game.vala"
							_tmp13_ = _tmp12_;
#line 172 "../src/game.vala"
							_tmp14_ = g_strconcat (_tmp7_, _tmp13_, NULL);
#line 172 "../src/game.vala"
							_g_free0 (s);
#line 172 "../src/game.vala"
							s = _tmp14_;
#line 172 "../src/game.vala"
							_g_free0 (_tmp13_);
#line 172 "../src/game.vala"
							_g_free0 (_tmp11_);
#line 1177 "game.c"
						}
					}
				}
#line 173 "../src/game.vala"
				_tmp15_ = s;
#line 173 "../src/game.vala"
				_tmp16_ = g_strconcat (_tmp15_, "\n", NULL);
#line 173 "../src/game.vala"
				_g_free0 (s);
#line 173 "../src/game.vala"
				s = _tmp16_;
#line 1189 "game.c"
			}
		}
	}
#line 176 "../src/game.vala"
	result = s;
#line 176 "../src/game.vala"
	return result;
#line 1197 "game.c"
}

Game*
game_construct_copy (GType object_type,
                     Game* game)
{
	Game * self = NULL;
	guint8 _tmp0_;
	guint8 _tmp10_;
	Player _tmp11_;
	guint8 _tmp12_;
	guint8 _tmp13_;
	guint8 _tmp14_;
	guint8 _tmp15_;
	guint8** _tmp16_ = NULL;
	gint _tmp17_ = 0;
#line 179 "../src/game.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 181 "../src/game.vala"
	_tmp0_ = game->priv->_size;
#line 181 "../src/game.vala"
	self = (Game*) g_object_new (object_type, "size", _tmp0_, NULL);
#line 1220 "game.c"
	{
		guint8 x = 0U;
#line 183 "../src/game.vala"
		x = (guint8) 0;
#line 1225 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 183 "../src/game.vala"
			_tmp1_ = TRUE;
#line 183 "../src/game.vala"
			while (TRUE) {
#line 1232 "game.c"
				guint8 _tmp3_;
#line 183 "../src/game.vala"
				if (!_tmp1_) {
#line 1236 "game.c"
					guint8 _tmp2_;
#line 183 "../src/game.vala"
					_tmp2_ = x;
#line 183 "../src/game.vala"
					x = _tmp2_ + 1;
#line 1242 "game.c"
				}
#line 183 "../src/game.vala"
				_tmp1_ = FALSE;
#line 183 "../src/game.vala"
				_tmp3_ = self->priv->_size;
#line 183 "../src/game.vala"
				if (!(x < _tmp3_)) {
#line 183 "../src/game.vala"
					break;
#line 1252 "game.c"
				}
				{
					guint8 y = 0U;
#line 184 "../src/game.vala"
					y = (guint8) 0;
#line 1258 "game.c"
					{
						gboolean _tmp4_ = FALSE;
#line 184 "../src/game.vala"
						_tmp4_ = TRUE;
#line 184 "../src/game.vala"
						while (TRUE) {
#line 1265 "game.c"
							guint8 _tmp6_;
							Player* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							Player* _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							Player _tmp9_;
#line 184 "../src/game.vala"
							if (!_tmp4_) {
#line 1276 "game.c"
								guint8 _tmp5_;
#line 184 "../src/game.vala"
								_tmp5_ = y;
#line 184 "../src/game.vala"
								y = _tmp5_ + 1;
#line 1282 "game.c"
							}
#line 184 "../src/game.vala"
							_tmp4_ = FALSE;
#line 184 "../src/game.vala"
							_tmp6_ = self->priv->_size;
#line 184 "../src/game.vala"
							if (!(y < _tmp6_)) {
#line 184 "../src/game.vala"
								break;
#line 1292 "game.c"
							}
#line 185 "../src/game.vala"
							_tmp7_ = self->priv->tiles;
#line 185 "../src/game.vala"
							_tmp7__length1 = self->priv->tiles_length1;
#line 185 "../src/game.vala"
							_tmp7__length2 = self->priv->tiles_length2;
#line 185 "../src/game.vala"
							_tmp8_ = game->priv->tiles;
#line 185 "../src/game.vala"
							_tmp8__length1 = game->priv->tiles_length1;
#line 185 "../src/game.vala"
							_tmp8__length2 = game->priv->tiles_length2;
#line 185 "../src/game.vala"
							_tmp9_ = _tmp8_[(x * _tmp8__length2) + y];
#line 185 "../src/game.vala"
							_tmp7_[(x * _tmp7__length2) + y] = _tmp9_;
#line 1310 "game.c"
						}
					}
				}
			}
		}
	}
#line 187 "../src/game.vala"
	_tmp10_ = game->priv->_number_of_moves;
#line 187 "../src/game.vala"
	game_set_number_of_moves (self, _tmp10_);
#line 188 "../src/game.vala"
	_tmp11_ = game->priv->_current_color;
#line 188 "../src/game.vala"
	game_set_current_color (self, _tmp11_);
#line 189 "../src/game.vala"
	_tmp12_ = game_get_n_current_tiles (game);
#line 189 "../src/game.vala"
	_tmp13_ = _tmp12_;
#line 189 "../src/game.vala"
	game_set_n_current_tiles (self, _tmp13_);
#line 190 "../src/game.vala"
	_tmp14_ = game_get_n_opponent_tiles (game);
#line 190 "../src/game.vala"
	_tmp15_ = _tmp14_;
#line 190 "../src/game.vala"
	game_set_n_opponent_tiles (self, _tmp15_);
#line 192 "../src/game.vala"
	game_init_undo_stack (self->priv->_size, &_tmp16_, &_tmp17_);
#line 192 "../src/game.vala"
	self->priv->undo_stack = (_vala_array_free (self->priv->undo_stack, self->priv->undo_stack_length1, (GDestroyNotify) g_free), NULL);
#line 192 "../src/game.vala"
	self->priv->undo_stack = _tmp16_;
#line 192 "../src/game.vala"
	self->priv->undo_stack_length1 = _tmp17_;
#line 192 "../src/game.vala"
	self->priv->_undo_stack_size_ = self->priv->undo_stack_length1;
#line 179 "../src/game.vala"
	return self;
#line 1349 "game.c"
}

Game*
game_new_copy (Game* game)
{
#line 179 "../src/game.vala"
	return game_construct_copy (TYPE_GAME, game);
#line 1357 "game.c"
}

inline gboolean
game_is_valid_location_signed (Game* self,
                               gint8 x,
                               gint8 y)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 200 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 202 "../src/game.vala"
	if (((gint) x) >= 0) {
#line 1373 "game.c"
		guint8 _tmp3_;
#line 202 "../src/game.vala"
		_tmp3_ = self->priv->_size;
#line 202 "../src/game.vala"
		_tmp2_ = ((guint8) x) < _tmp3_;
#line 1379 "game.c"
	} else {
#line 202 "../src/game.vala"
		_tmp2_ = FALSE;
#line 1383 "game.c"
	}
#line 202 "../src/game.vala"
	if (_tmp2_) {
#line 203 "../src/game.vala"
		_tmp1_ = ((gint) y) >= 0;
#line 1389 "game.c"
	} else {
#line 202 "../src/game.vala"
		_tmp1_ = FALSE;
#line 1393 "game.c"
	}
#line 202 "../src/game.vala"
	if (_tmp1_) {
#line 1397 "game.c"
		guint8 _tmp4_;
#line 203 "../src/game.vala"
		_tmp4_ = self->priv->_size;
#line 203 "../src/game.vala"
		_tmp0_ = ((guint8) y) < _tmp4_;
#line 1403 "game.c"
	} else {
#line 202 "../src/game.vala"
		_tmp0_ = FALSE;
#line 1407 "game.c"
	}
#line 202 "../src/game.vala"
	result = _tmp0_;
#line 202 "../src/game.vala"
	return result;
#line 1413 "game.c"
}

inline gboolean
game_is_valid_location_unsigned (Game* self,
                                 guint8 x,
                                 guint8 y)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	guint8 _tmp1_;
#line 206 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 208 "../src/game.vala"
	_tmp1_ = self->priv->_size;
#line 208 "../src/game.vala"
	if (x < _tmp1_) {
#line 1430 "game.c"
		guint8 _tmp2_;
#line 208 "../src/game.vala"
		_tmp2_ = self->priv->_size;
#line 208 "../src/game.vala"
		_tmp0_ = y < _tmp2_;
#line 1436 "game.c"
	} else {
#line 208 "../src/game.vala"
		_tmp0_ = FALSE;
#line 1440 "game.c"
	}
#line 208 "../src/game.vala"
	result = _tmp0_;
#line 208 "../src/game.vala"
	return result;
#line 1446 "game.c"
}

Player
game_get_owner (Game* self,
                guint8 x,
                guint8 y)
{
	Player result = 0;
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
#line 211 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 211 "../src/game.vala"
	_vala_return_val_if_fail (game_is_valid_location_unsigned (self, x, y), "is_valid_location_unsigned (x, y)", 0);
#line 214 "../src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 214 "../src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 214 "../src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 214 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 214 "../src/game.vala"
	result = _tmp1_;
#line 214 "../src/game.vala"
	return result;
#line 1475 "game.c"
}

gboolean
game_can_place (Game* self,
                guint8 x,
                guint8 y,
                Player color)
{
	gboolean result = FALSE;
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
#line 217 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 217 "../src/game.vala"
	_vala_return_val_if_fail (game_is_valid_location_unsigned (self, x, y), "is_valid_location_unsigned (x, y)", FALSE);
#line 217 "../src/game.vala"
	_vala_return_val_if_fail (color != PLAYER_NONE, "color != Player.NONE", FALSE);
#line 221 "../src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 221 "../src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 221 "../src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 221 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 221 "../src/game.vala"
	if (_tmp1_ != PLAYER_NONE) {
#line 222 "../src/game.vala"
		result = FALSE;
#line 222 "../src/game.vala"
		return result;
#line 1509 "game.c"
	}
#line 224 "../src/game.vala"
	if (((gint) game_can_flip_tiles (self, x, y, (gint8) 1, (gint8) 0, color)) > 0) {
#line 224 "../src/game.vala"
		result = TRUE;
#line 224 "../src/game.vala"
		return result;
#line 1517 "game.c"
	}
#line 225 "../src/game.vala"
	if (((gint) game_can_flip_tiles (self, x, y, (gint8) 1, (gint8) 1, color)) > 0) {
#line 225 "../src/game.vala"
		result = TRUE;
#line 225 "../src/game.vala"
		return result;
#line 1525 "game.c"
	}
#line 226 "../src/game.vala"
	if (((gint) game_can_flip_tiles (self, x, y, (gint8) 0, (gint8) 1, color)) > 0) {
#line 226 "../src/game.vala"
		result = TRUE;
#line 226 "../src/game.vala"
		return result;
#line 1533 "game.c"
	}
#line 227 "../src/game.vala"
	if (((gint) game_can_flip_tiles (self, x, y, (gint8) -1, (gint8) 1, color)) > 0) {
#line 227 "../src/game.vala"
		result = TRUE;
#line 227 "../src/game.vala"
		return result;
#line 1541 "game.c"
	}
#line 228 "../src/game.vala"
	if (((gint) game_can_flip_tiles (self, x, y, (gint8) -1, (gint8) 0, color)) > 0) {
#line 228 "../src/game.vala"
		result = TRUE;
#line 228 "../src/game.vala"
		return result;
#line 1549 "game.c"
	}
#line 229 "../src/game.vala"
	if (((gint) game_can_flip_tiles (self, x, y, (gint8) -1, (gint8) -1, color)) > 0) {
#line 229 "../src/game.vala"
		result = TRUE;
#line 229 "../src/game.vala"
		return result;
#line 1557 "game.c"
	}
#line 230 "../src/game.vala"
	if (((gint) game_can_flip_tiles (self, x, y, (gint8) 0, (gint8) -1, color)) > 0) {
#line 230 "../src/game.vala"
		result = TRUE;
#line 230 "../src/game.vala"
		return result;
#line 1565 "game.c"
	}
#line 231 "../src/game.vala"
	if (((gint) game_can_flip_tiles (self, x, y, (gint8) 1, (gint8) -1, color)) > 0) {
#line 231 "../src/game.vala"
		result = TRUE;
#line 231 "../src/game.vala"
		return result;
#line 1573 "game.c"
	}
#line 232 "../src/game.vala"
	result = FALSE;
#line 232 "../src/game.vala"
	return result;
#line 1579 "game.c"
}

guint8
game_place_tile (Game* self,
                 guint8 x,
                 guint8 y,
                 gboolean apply)
{
	guint8 result = 0U;
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
	guint8 tiles_turned = 0U;
#line 239 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 239 "../src/game.vala"
	_vala_return_val_if_fail (game_is_valid_location_unsigned (self, x, y), "is_valid_location_unsigned (x, y)", 0U);
#line 242 "../src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 242 "../src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 242 "../src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 242 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 242 "../src/game.vala"
	if (_tmp1_ != PLAYER_NONE) {
#line 243 "../src/game.vala"
		result = (guint8) 0;
#line 243 "../src/game.vala"
		return result;
#line 1612 "game.c"
	}
#line 245 "../src/game.vala"
	tiles_turned = (guint8) 0;
#line 246 "../src/game.vala"
	tiles_turned = tiles_turned + game_flip_tiles (self, x, y, (gint8) 1, (gint8) 0, apply);
#line 247 "../src/game.vala"
	tiles_turned = tiles_turned + game_flip_tiles (self, x, y, (gint8) 1, (gint8) 1, apply);
#line 248 "../src/game.vala"
	tiles_turned = tiles_turned + game_flip_tiles (self, x, y, (gint8) 0, (gint8) 1, apply);
#line 249 "../src/game.vala"
	tiles_turned = tiles_turned + game_flip_tiles (self, x, y, (gint8) -1, (gint8) 1, apply);
#line 250 "../src/game.vala"
	tiles_turned = tiles_turned + game_flip_tiles (self, x, y, (gint8) -1, (gint8) 0, apply);
#line 251 "../src/game.vala"
	tiles_turned = tiles_turned + game_flip_tiles (self, x, y, (gint8) -1, (gint8) -1, apply);
#line 252 "../src/game.vala"
	tiles_turned = tiles_turned + game_flip_tiles (self, x, y, (gint8) 0, (gint8) -1, apply);
#line 253 "../src/game.vala"
	tiles_turned = tiles_turned + game_flip_tiles (self, x, y, (gint8) 1, (gint8) -1, apply);
#line 255 "../src/game.vala"
	if (((gint) tiles_turned) == 0) {
#line 256 "../src/game.vala"
		result = (guint8) 0;
#line 256 "../src/game.vala"
		return result;
#line 1638 "game.c"
	}
#line 258 "../src/game.vala"
	if (apply) {
#line 260 "../src/game.vala"
		game_set_tile (self, x, y);
#line 261 "../src/game.vala"
		game_end_of_turn (self);
#line 1646 "game.c"
	}
#line 264 "../src/game.vala"
	result = tiles_turned;
#line 264 "../src/game.vala"
	return result;
#line 1652 "game.c"
}

void
game_pass (Game* self)
{
	gboolean _tmp0_;
#line 267 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 267 "../src/game.vala"
	_tmp0_ = self->priv->_current_player_can_move;
#line 267 "../src/game.vala"
	_vala_return_if_fail (!_tmp0_, "!current_player_can_move");
#line 270 "../src/game.vala"
	game_end_of_turn (self);
#line 1667 "game.c"
}

static void
game_end_of_turn (Game* self)
{
	guint8** _tmp0_;
	gint _tmp0__length1;
	Player _tmp1_;
	guint8 _tmp2_;
	gint _tmp3_;
	guint8** _tmp4_;
	gint _tmp4__length1;
#line 273 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 273 "../src/game.vala"
	_tmp0_ = self->priv->undo_stack;
#line 273 "../src/game.vala"
	_tmp0__length1 = self->priv->undo_stack_length1;
#line 273 "../src/game.vala"
	_vala_return_if_fail ((self->priv->history_index >= -1) && (self->priv->history_index < (_tmp0__length1 - 2)), "history_index >= -1 && history_index < undo_stack.length - 2");
#line 276 "../src/game.vala"
	_tmp1_ = self->priv->_current_color;
#line 276 "../src/game.vala"
	game_set_current_color (self, player_flip_color (_tmp1_));
#line 277 "../src/game.vala"
	_tmp2_ = self->priv->_number_of_moves;
#line 277 "../src/game.vala"
	game_set_number_of_moves (self, _tmp2_ + 1);
#line 278 "../src/game.vala"
	_tmp3_ = self->priv->history_index;
#line 278 "../src/game.vala"
	self->priv->history_index = _tmp3_ + 1;
#line 279 "../src/game.vala"
	_tmp4_ = self->priv->undo_stack;
#line 279 "../src/game.vala"
	_tmp4__length1 = self->priv->undo_stack_length1;
#line 279 "../src/game.vala"
	_g_free0 (_tmp4_[self->priv->history_index]);
#line 279 "../src/game.vala"
	_tmp4_[self->priv->history_index] = NULL;
#line 280 "../src/game.vala"
	game_update_who_can_move (self);
#line 281 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_TURN_ENDED_SIGNAL], 0);
#line 1712 "game.c"
}

static void
game_update_who_can_move (Game* self)
{
	Player enemy = 0;
	Player _tmp0_;
	gboolean opponent_can_move = FALSE;
#line 284 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 286 "../src/game.vala"
	_tmp0_ = self->priv->_current_color;
#line 286 "../src/game.vala"
	enemy = player_flip_color (_tmp0_);
#line 287 "../src/game.vala"
	opponent_can_move = FALSE;
#line 1729 "game.c"
	{
		guint8 x = 0U;
#line 288 "../src/game.vala"
		x = (guint8) 0;
#line 1734 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 288 "../src/game.vala"
			_tmp1_ = TRUE;
#line 288 "../src/game.vala"
			while (TRUE) {
#line 1741 "game.c"
				guint8 _tmp3_;
#line 288 "../src/game.vala"
				if (!_tmp1_) {
#line 1745 "game.c"
					guint8 _tmp2_;
#line 288 "../src/game.vala"
					_tmp2_ = x;
#line 288 "../src/game.vala"
					x = _tmp2_ + 1;
#line 1751 "game.c"
				}
#line 288 "../src/game.vala"
				_tmp1_ = FALSE;
#line 288 "../src/game.vala"
				_tmp3_ = self->priv->_size;
#line 288 "../src/game.vala"
				if (!(x < _tmp3_)) {
#line 288 "../src/game.vala"
					break;
#line 1761 "game.c"
				}
				{
					guint8 y = 0U;
#line 290 "../src/game.vala"
					y = (guint8) 0;
#line 1767 "game.c"
					{
						gboolean _tmp4_ = FALSE;
#line 290 "../src/game.vala"
						_tmp4_ = TRUE;
#line 290 "../src/game.vala"
						while (TRUE) {
#line 1774 "game.c"
							guint8 _tmp6_;
							Player _tmp7_;
							Player _tmp8_;
#line 290 "../src/game.vala"
							if (!_tmp4_) {
#line 1780 "game.c"
								guint8 _tmp5_;
#line 290 "../src/game.vala"
								_tmp5_ = y;
#line 290 "../src/game.vala"
								y = _tmp5_ + 1;
#line 1786 "game.c"
							}
#line 290 "../src/game.vala"
							_tmp4_ = FALSE;
#line 290 "../src/game.vala"
							_tmp6_ = self->priv->_size;
#line 290 "../src/game.vala"
							if (!(y < _tmp6_)) {
#line 290 "../src/game.vala"
								break;
#line 1796 "game.c"
							}
#line 292 "../src/game.vala"
							_tmp7_ = self->priv->_current_color;
#line 292 "../src/game.vala"
							if (game_can_place (self, x, y, _tmp7_)) {
#line 294 "../src/game.vala"
								game_set_current_player_can_move (self, TRUE);
#line 295 "../src/game.vala"
								return;
#line 1806 "game.c"
							}
#line 297 "../src/game.vala"
							_tmp8_ = enemy;
#line 297 "../src/game.vala"
							if (game_can_place (self, x, y, _tmp8_)) {
#line 298 "../src/game.vala"
								opponent_can_move = TRUE;
#line 1814 "game.c"
							}
						}
					}
				}
			}
		}
	}
#line 301 "../src/game.vala"
	game_set_current_player_can_move (self, FALSE);
#line 302 "../src/game.vala"
	if (!opponent_can_move) {
#line 303 "../src/game.vala"
		game_set_is_complete (self, TRUE);
#line 1828 "game.c"
	}
}

static guint8
game_flip_tiles (Game* self,
                 guint8 x,
                 guint8 y,
                 gint8 x_step,
                 gint8 y_step,
                 gboolean apply)
{
	guint8 result = 0U;
	guint8 enemy_count = 0U;
	Player _tmp0_;
#line 310 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 312 "../src/game.vala"
	_tmp0_ = self->priv->_current_color;
#line 312 "../src/game.vala"
	enemy_count = game_can_flip_tiles (self, x, y, x_step, y_step, _tmp0_);
#line 313 "../src/game.vala"
	if (((gint) enemy_count) == 0) {
#line 314 "../src/game.vala"
		result = (guint8) 0;
#line 314 "../src/game.vala"
		return result;
#line 1855 "game.c"
	}
#line 316 "../src/game.vala"
	if (apply) {
#line 1859 "game.c"
		{
			gint8 i = 0;
#line 318 "../src/game.vala"
			i = (gint8) 1;
#line 1864 "game.c"
			{
				gboolean _tmp1_ = FALSE;
#line 318 "../src/game.vala"
				_tmp1_ = TRUE;
#line 318 "../src/game.vala"
				while (TRUE) {
#line 1871 "game.c"
					guint8 _tmp3_;
					guint8 _tmp4_;
#line 318 "../src/game.vala"
					if (!_tmp1_) {
#line 1876 "game.c"
						gint8 _tmp2_;
#line 318 "../src/game.vala"
						_tmp2_ = i;
#line 318 "../src/game.vala"
						i = _tmp2_ + 1;
#line 1882 "game.c"
					}
#line 318 "../src/game.vala"
					_tmp1_ = FALSE;
#line 318 "../src/game.vala"
					if (!(((guint8) i) <= enemy_count)) {
#line 318 "../src/game.vala"
						break;
#line 1890 "game.c"
					}
#line 320 "../src/game.vala"
					_tmp3_ = game_get_n_opponent_tiles (self);
#line 320 "../src/game.vala"
					_tmp4_ = _tmp3_;
#line 320 "../src/game.vala"
					game_set_n_opponent_tiles (self, _tmp4_ - 1);
#line 321 "../src/game.vala"
					game_set_tile (self, x + ((guint8) (i * x_step)), y + ((guint8) (i * y_step)));
#line 1900 "game.c"
				}
			}
		}
	}
#line 325 "../src/game.vala"
	result = enemy_count;
#line 325 "../src/game.vala"
	return result;
#line 1909 "game.c"
}

static guint8
game_can_flip_tiles (Game* self,
                     guint8 x,
                     guint8 y,
                     gint8 x_step,
                     gint8 y_step,
                     Player color)
{
	guint8 result = 0U;
	Player enemy = 0;
	gint8 enemy_count = 0;
	gint8 xt = 0;
	gint8 yt = 0;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
#line 328 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 330 "../src/game.vala"
	enemy = player_flip_color (color);
#line 333 "../src/game.vala"
	enemy_count = (gint8) -1;
#line 334 "../src/game.vala"
	xt = (gint8) x;
#line 335 "../src/game.vala"
	yt = (gint8) y;
#line 1937 "game.c"
	{
		gboolean _tmp0_ = FALSE;
#line 336 "../src/game.vala"
		_tmp0_ = TRUE;
#line 336 "../src/game.vala"
		while (TRUE) {
#line 1944 "game.c"
			gint8 _tmp5_;
#line 336 "../src/game.vala"
			if (!_tmp0_) {
#line 1948 "game.c"
				gboolean _tmp1_ = FALSE;
#line 340 "../src/game.vala"
				if (game_is_valid_location_signed (self, xt, yt)) {
#line 1952 "game.c"
					Player* _tmp2_;
					gint _tmp2__length1;
					gint _tmp2__length2;
					Player _tmp3_;
					Player _tmp4_;
#line 340 "../src/game.vala"
					_tmp2_ = self->priv->tiles;
#line 340 "../src/game.vala"
					_tmp2__length1 = self->priv->tiles_length1;
#line 340 "../src/game.vala"
					_tmp2__length2 = self->priv->tiles_length2;
#line 340 "../src/game.vala"
					_tmp3_ = _tmp2_[(xt * _tmp2__length2) + yt];
#line 340 "../src/game.vala"
					_tmp4_ = enemy;
#line 340 "../src/game.vala"
					_tmp1_ = _tmp3_ == _tmp4_;
#line 1970 "game.c"
				} else {
#line 340 "../src/game.vala"
					_tmp1_ = FALSE;
#line 1974 "game.c"
				}
#line 340 "../src/game.vala"
				if (!_tmp1_) {
#line 340 "../src/game.vala"
					break;
#line 1980 "game.c"
				}
			}
#line 336 "../src/game.vala"
			_tmp0_ = FALSE;
#line 337 "../src/game.vala"
			_tmp5_ = enemy_count;
#line 337 "../src/game.vala"
			enemy_count = _tmp5_ + 1;
#line 338 "../src/game.vala"
			xt = xt + x_step;
#line 339 "../src/game.vala"
			yt = yt + y_step;
#line 1993 "game.c"
		}
	}
#line 343 "../src/game.vala"
	if (((gint) enemy_count) == 0) {
#line 343 "../src/game.vala"
		_tmp7_ = TRUE;
#line 2000 "game.c"
	} else {
#line 343 "../src/game.vala"
		_tmp7_ = !game_is_valid_location_signed (self, xt, yt);
#line 2004 "game.c"
	}
#line 343 "../src/game.vala"
	if (_tmp7_) {
#line 343 "../src/game.vala"
		_tmp6_ = TRUE;
#line 2010 "game.c"
	} else {
		Player* _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		Player _tmp9_;
#line 343 "../src/game.vala"
		_tmp8_ = self->priv->tiles;
#line 343 "../src/game.vala"
		_tmp8__length1 = self->priv->tiles_length1;
#line 343 "../src/game.vala"
		_tmp8__length2 = self->priv->tiles_length2;
#line 343 "../src/game.vala"
		_tmp9_ = _tmp8_[(xt * _tmp8__length2) + yt];
#line 343 "../src/game.vala"
		_tmp6_ = _tmp9_ != color;
#line 2026 "game.c"
	}
#line 343 "../src/game.vala"
	if (_tmp6_) {
#line 344 "../src/game.vala"
		result = (guint8) 0;
#line 344 "../src/game.vala"
		return result;
#line 2034 "game.c"
	}
#line 346 "../src/game.vala"
	result = (guint8) enemy_count;
#line 346 "../src/game.vala"
	return result;
#line 2040 "game.c"
}

static guint8*
_uint8_dup (guint8* self)
{
	guint8* dup;
#line 354 "../src/game.vala"
	dup = g_new0 (guint8, 1);
#line 354 "../src/game.vala"
	memcpy (dup, self, sizeof (guint8));
#line 354 "../src/game.vala"
	return dup;
#line 2053 "game.c"
}

static gpointer
__uint8_dup0 (gpointer self)
{
#line 354 "../src/game.vala"
	return self ? _uint8_dup (self) : NULL;
#line 2061 "game.c"
}

static void
game_set_tile (Game* self,
               guint8 x,
               guint8 y)
{
	guint8** _tmp0_;
	gint _tmp0__length1;
	guint8 _tmp1_;
	guint8 _tmp2_;
	gint _tmp3_;
	guint8** _tmp4_;
	gint _tmp4__length1;
	guint8 _tmp5_;
	guint8 _tmp6_;
	guint8* _tmp7_;
	Player* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	Player _tmp9_;
	Player _tmp10_;
#line 349 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 349 "../src/game.vala"
	_tmp0_ = self->priv->undo_stack;
#line 349 "../src/game.vala"
	_tmp0__length1 = self->priv->undo_stack_length1;
#line 349 "../src/game.vala"
	_vala_return_if_fail ((self->priv->history_index >= -1) && (self->priv->history_index < (_tmp0__length1 - 2)), "history_index >= -1 && history_index < undo_stack.length - 2");
#line 352 "../src/game.vala"
	_tmp1_ = game_get_n_current_tiles (self);
#line 352 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 352 "../src/game.vala"
	game_set_n_current_tiles (self, _tmp2_ + 1);
#line 353 "../src/game.vala"
	_tmp3_ = self->priv->history_index;
#line 353 "../src/game.vala"
	self->priv->history_index = _tmp3_ + 1;
#line 354 "../src/game.vala"
	_tmp4_ = self->priv->undo_stack;
#line 354 "../src/game.vala"
	_tmp4__length1 = self->priv->undo_stack_length1;
#line 354 "../src/game.vala"
	_tmp5_ = self->priv->_size;
#line 354 "../src/game.vala"
	_tmp6_ = x + (y * _tmp5_);
#line 354 "../src/game.vala"
	_tmp7_ = __uint8_dup0 (&_tmp6_);
#line 354 "../src/game.vala"
	_g_free0 (_tmp4_[self->priv->history_index]);
#line 354 "../src/game.vala"
	_tmp4_[self->priv->history_index] = _tmp7_;
#line 355 "../src/game.vala"
	_tmp8_ = self->priv->tiles;
#line 355 "../src/game.vala"
	_tmp8__length1 = self->priv->tiles_length1;
#line 355 "../src/game.vala"
	_tmp8__length2 = self->priv->tiles_length2;
#line 355 "../src/game.vala"
	_tmp9_ = self->priv->_current_color;
#line 355 "../src/game.vala"
	_tmp8_[(x * _tmp8__length2) + y] = _tmp9_;
#line 356 "../src/game.vala"
	_tmp10_ = self->priv->_current_color;
#line 356 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_SQUARE_CHANGED_SIGNAL], 0, x, y, _tmp10_);
#line 2130 "game.c"
}

void
game_undo (Game* self,
           guint8 count)
{
	guint8 _tmp0_;
	guint8** _tmp1_;
	gint _tmp1__length1;
	Player enemy = 0;
	Player _tmp2_;
	Player _tmp3_;
	guint8 _tmp4_;
	gint _tmp5_;
	guint8* undo_item = NULL;
	guint8** _tmp6_;
	gint _tmp6__length1;
	guint8* _tmp7_;
	guint8* _tmp8_;
	guint8* _tmp9_;
#line 363 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 363 "../src/game.vala"
	_vala_return_if_fail ((((gint) count) == 1) || (((gint) count) == 2), "count == 1 || count == 2");
#line 363 "../src/game.vala"
	_tmp0_ = self->priv->_number_of_moves;
#line 363 "../src/game.vala"
	_vala_return_if_fail (_tmp0_ >= count, "number_of_moves >= count");
#line 363 "../src/game.vala"
	_tmp1_ = self->priv->undo_stack;
#line 363 "../src/game.vala"
	_tmp1__length1 = self->priv->undo_stack_length1;
#line 363 "../src/game.vala"
	_vala_return_if_fail (self->priv->history_index < _tmp1__length1, "history_index < undo_stack.length");
#line 368 "../src/game.vala"
	_tmp2_ = self->priv->_current_color;
#line 368 "../src/game.vala"
	enemy = _tmp2_;
#line 369 "../src/game.vala"
	_tmp3_ = self->priv->_current_color;
#line 369 "../src/game.vala"
	game_set_current_color (self, player_flip_color (_tmp3_));
#line 370 "../src/game.vala"
	_tmp4_ = self->priv->_number_of_moves;
#line 370 "../src/game.vala"
	game_set_number_of_moves (self, _tmp4_ - 1);
#line 373 "../src/game.vala"
	_tmp5_ = self->priv->history_index;
#line 373 "../src/game.vala"
	self->priv->history_index = _tmp5_ - 1;
#line 376 "../src/game.vala"
	_tmp6_ = self->priv->undo_stack;
#line 376 "../src/game.vala"
	_tmp6__length1 = self->priv->undo_stack_length1;
#line 376 "../src/game.vala"
	_tmp7_ = _tmp6_[self->priv->history_index];
#line 376 "../src/game.vala"
	_tmp8_ = __uint8_dup0 (_tmp7_);
#line 376 "../src/game.vala"
	undo_item = _tmp8_;
#line 377 "../src/game.vala"
	_tmp9_ = undo_item;
#line 377 "../src/game.vala"
	if (_tmp9_ != NULL) {
#line 2195 "game.c"
		guint8* _tmp10_;
		guint8** _tmp11_;
		gint _tmp11__length1;
		guint8* _tmp12_;
		guint8* _tmp13_;
#line 380 "../src/game.vala"
		_tmp10_ = undo_item;
#line 380 "../src/game.vala"
		game_unset_tile (self, (guint8) (*_tmp10_), PLAYER_NONE);
#line 381 "../src/game.vala"
		_tmp11_ = self->priv->undo_stack;
#line 381 "../src/game.vala"
		_tmp11__length1 = self->priv->undo_stack_length1;
#line 381 "../src/game.vala"
		_tmp12_ = _tmp11_[self->priv->history_index];
#line 381 "../src/game.vala"
		_tmp13_ = __uint8_dup0 (_tmp12_);
#line 381 "../src/game.vala"
		_g_free0 (undo_item);
#line 381 "../src/game.vala"
		undo_item = _tmp13_;
#line 382 "../src/game.vala"
		while (TRUE) {
#line 2219 "game.c"
			gboolean _tmp14_ = FALSE;
			guint8 _tmp16_;
			guint8 _tmp17_;
			guint8* _tmp18_;
			Player _tmp19_;
#line 382 "../src/game.vala"
			if (self->priv->history_index > -1) {
#line 2227 "game.c"
				guint8* _tmp15_;
#line 382 "../src/game.vala"
				_tmp15_ = undo_item;
#line 382 "../src/game.vala"
				_tmp14_ = _tmp15_ != NULL;
#line 2233 "game.c"
			} else {
#line 382 "../src/game.vala"
				_tmp14_ = FALSE;
#line 2237 "game.c"
			}
#line 382 "../src/game.vala"
			if (!_tmp14_) {
#line 382 "../src/game.vala"
				break;
#line 2243 "game.c"
			}
#line 384 "../src/game.vala"
			_tmp16_ = game_get_n_opponent_tiles (self);
#line 384 "../src/game.vala"
			_tmp17_ = _tmp16_;
#line 384 "../src/game.vala"
			game_set_n_opponent_tiles (self, _tmp17_ + 1);
#line 385 "../src/game.vala"
			_tmp18_ = undo_item;
#line 385 "../src/game.vala"
			_tmp19_ = enemy;
#line 385 "../src/game.vala"
			game_unset_tile (self, (guint8) (*_tmp18_), _tmp19_);
#line 386 "../src/game.vala"
			if (self->priv->history_index > -1) {
#line 2259 "game.c"
				guint8** _tmp20_;
				gint _tmp20__length1;
				guint8* _tmp21_;
				guint8* _tmp22_;
#line 387 "../src/game.vala"
				_tmp20_ = self->priv->undo_stack;
#line 387 "../src/game.vala"
				_tmp20__length1 = self->priv->undo_stack_length1;
#line 387 "../src/game.vala"
				_tmp21_ = _tmp20_[self->priv->history_index];
#line 387 "../src/game.vala"
				_tmp22_ = __uint8_dup0 (_tmp21_);
#line 387 "../src/game.vala"
				_g_free0 (undo_item);
#line 387 "../src/game.vala"
				undo_item = _tmp22_;
#line 2276 "game.c"
			} else {
#line 389 "../src/game.vala"
				_g_free0 (undo_item);
#line 389 "../src/game.vala"
				undo_item = NULL;
#line 2282 "game.c"
			}
		}
	}
#line 393 "../src/game.vala"
	if (((gint) count) == 1) {
#line 395 "../src/game.vala"
		game_set_is_complete (self, FALSE);
#line 396 "../src/game.vala"
		game_update_who_can_move (self);
#line 2292 "game.c"
	} else {
#line 400 "../src/game.vala"
		game_undo (self, (guint8) (count - 1));
#line 2296 "game.c"
	}
#line 363 "../src/game.vala"
	_g_free0 (undo_item);
#line 2300 "game.c"
}

static void
game_unset_tile (Game* self,
                 guint8 tile_number,
                 Player replacement_color)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	gint _tmp2_;
	guint8 x = 0U;
	guint8 _tmp3_;
	guint8 y = 0U;
	guint8 _tmp4_;
	Player* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
#line 404 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 406 "../src/game.vala"
	_tmp0_ = game_get_n_current_tiles (self);
#line 406 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 406 "../src/game.vala"
	game_set_n_current_tiles (self, _tmp1_ - 1);
#line 407 "../src/game.vala"
	_tmp2_ = self->priv->history_index;
#line 407 "../src/game.vala"
	self->priv->history_index = _tmp2_ - 1;
#line 408 "../src/game.vala"
	_tmp3_ = self->priv->_size;
#line 408 "../src/game.vala"
	x = tile_number % _tmp3_;
#line 409 "../src/game.vala"
	_tmp4_ = self->priv->_size;
#line 409 "../src/game.vala"
	y = tile_number / _tmp4_;
#line 410 "../src/game.vala"
	_tmp5_ = self->priv->tiles;
#line 410 "../src/game.vala"
	_tmp5__length1 = self->priv->tiles_length1;
#line 410 "../src/game.vala"
	_tmp5__length2 = self->priv->tiles_length2;
#line 410 "../src/game.vala"
	_tmp5_[(x * _tmp5__length2) + y] = replacement_color;
#line 411 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_SQUARE_CHANGED_SIGNAL], 0, x, y, replacement_color);
#line 2348 "game.c"
}

static void
game_init_undo_stack (guint8 size,
                      guint8*** undo_stack,
                      gint* undo_stack_length1)
{
	guint8** _vala_undo_stack = NULL;
	gint _vala_undo_stack_length1 = 0;
	guint8** _tmp0_;
#line 420 "../src/game.vala"
	_tmp0_ = g_new0 (guint8*, ((size * size) - 4) * (3 + ((size - 2) * 4)));
#line 420 "../src/game.vala"
	_vala_undo_stack = (_vala_array_free (_vala_undo_stack, _vala_undo_stack_length1, (GDestroyNotify) g_free), NULL);
#line 420 "../src/game.vala"
	_vala_undo_stack = _tmp0_;
#line 420 "../src/game.vala"
	_vala_undo_stack_length1 = ((size * size) - 4) * (3 + ((size - 2) * 4));
#line 414 "../src/game.vala"
	if (undo_stack) {
#line 414 "../src/game.vala"
		*undo_stack = _vala_undo_stack;
#line 2371 "game.c"
	} else {
#line 414 "../src/game.vala"
		_vala_undo_stack = (_vala_array_free (_vala_undo_stack, _vala_undo_stack_length1, (GDestroyNotify) g_free), NULL);
#line 2375 "game.c"
	}
#line 414 "../src/game.vala"
	if (undo_stack_length1) {
#line 414 "../src/game.vala"
		*undo_stack_length1 = _vala_undo_stack_length1;
#line 2381 "game.c"
	}
}

guint8
game_get_size (Game* self)
{
	guint8 result;
#line 28 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 28 "../src/game.vala"
	result = self->priv->_size;
#line 28 "../src/game.vala"
	return result;
#line 2395 "game.c"
}

static void
game_set_size (Game* self,
               guint8 value)
{
#line 28 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/game.vala"
	self->priv->_size = value;
#line 2406 "game.c"
}

Player
game_get_current_color (Game* self)
{
	Player result;
	Player _tmp0_;
#line 36 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "../src/game.vala"
	_tmp0_ = self->priv->_current_color;
#line 36 "../src/game.vala"
	result = _tmp0_;
#line 36 "../src/game.vala"
	return result;
#line 2422 "game.c"
}

static void
game_set_current_color (Game* self,
                        Player value)
{
#line 36 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/game.vala"
	self->priv->_current_color = value;
#line 2433 "game.c"
}

guint8
game_get_number_of_moves (Game* self)
{
	guint8 result;
#line 37 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 37 "../src/game.vala"
	result = self->priv->_number_of_moves;
#line 37 "../src/game.vala"
	return result;
#line 2446 "game.c"
}

static void
game_set_number_of_moves (Game* self,
                          guint8 value)
{
#line 37 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/game.vala"
	self->priv->_number_of_moves = value;
#line 2457 "game.c"
}

gboolean
game_get_current_player_can_move (Game* self)
{
	gboolean result;
#line 40 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 40 "../src/game.vala"
	result = self->priv->_current_player_can_move;
#line 40 "../src/game.vala"
	return result;
#line 2470 "game.c"
}

static void
game_set_current_player_can_move (Game* self,
                                  gboolean value)
{
#line 40 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/game.vala"
	self->priv->_current_player_can_move = value;
#line 2481 "game.c"
}

gboolean
game_get_is_complete (Game* self)
{
	gboolean result;
#line 41 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../src/game.vala"
	result = self->priv->_is_complete;
#line 41 "../src/game.vala"
	return result;
#line 2494 "game.c"
}

static void
game_set_is_complete (Game* self,
                      gboolean value)
{
#line 41 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/game.vala"
	if (game_get_is_complete (self) != value) {
#line 41 "../src/game.vala"
		self->priv->_is_complete = value;
#line 41 "../src/game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_IS_COMPLETE_PROPERTY]);
#line 2509 "game.c"
	}
}

guint8
game_get_initial_number_of_tiles (Game* self)
{
	guint8 result;
#line 52 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 52 "../src/game.vala"
	result = self->priv->_initial_number_of_tiles;
#line 52 "../src/game.vala"
	return result;
#line 2523 "game.c"
}

static void
game_set_initial_number_of_tiles (Game* self,
                                  guint8 value)
{
#line 52 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/game.vala"
	self->priv->_initial_number_of_tiles = value;
#line 2534 "game.c"
}

guint8
game_get_n_tiles (Game* self)
{
	guint8 result;
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
#line 55 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 55 "../src/game.vala"
	_tmp0_ = game_get_n_dark_tiles (self);
#line 55 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 55 "../src/game.vala"
	_tmp2_ = game_get_n_light_tiles (self);
#line 55 "../src/game.vala"
	_tmp3_ = _tmp2_;
#line 55 "../src/game.vala"
	result = _tmp1_ + _tmp3_;
#line 55 "../src/game.vala"
	return result;
#line 2559 "game.c"
}

guint8
game_get_n_light_tiles (Game* self)
{
	guint8 result;
#line 61 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 61 "../src/game.vala"
	result = self->priv->_n_light_tiles;
#line 61 "../src/game.vala"
	return result;
#line 2572 "game.c"
}

guint8
game_get_n_dark_tiles (Game* self)
{
	guint8 result;
#line 67 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 67 "../src/game.vala"
	result = self->priv->_n_dark_tiles;
#line 67 "../src/game.vala"
	return result;
#line 2585 "game.c"
}

guint8
game_get_n_current_tiles (Game* self)
{
	guint8 result;
	guint8 _tmp0_ = 0U;
	Player _tmp1_;
#line 72 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 72 "../src/game.vala"
	_tmp1_ = self->priv->_current_color;
#line 72 "../src/game.vala"
	if (_tmp1_ == PLAYER_LIGHT) {
#line 2600 "game.c"
		guint8 _tmp2_;
		guint8 _tmp3_;
#line 72 "../src/game.vala"
		_tmp2_ = game_get_n_light_tiles (self);
#line 72 "../src/game.vala"
		_tmp3_ = _tmp2_;
#line 72 "../src/game.vala"
		_tmp0_ = _tmp3_;
#line 2609 "game.c"
	} else {
		guint8 _tmp4_;
		guint8 _tmp5_;
#line 72 "../src/game.vala"
		_tmp4_ = game_get_n_dark_tiles (self);
#line 72 "../src/game.vala"
		_tmp5_ = _tmp4_;
#line 72 "../src/game.vala"
		_tmp0_ = _tmp5_;
#line 2619 "game.c"
	}
#line 72 "../src/game.vala"
	result = _tmp0_;
#line 72 "../src/game.vala"
	return result;
#line 2625 "game.c"
}

static void
game_set_n_current_tiles (Game* self,
                          guint8 value)
{
	Player _tmp0_;
#line 73 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 74 "../src/game.vala"
	_tmp0_ = self->priv->_current_color;
#line 74 "../src/game.vala"
	if (_tmp0_ == PLAYER_LIGHT) {
#line 75 "../src/game.vala"
		self->priv->_n_light_tiles = value;
#line 2641 "game.c"
	} else {
#line 77 "../src/game.vala"
		self->priv->_n_dark_tiles = value;
#line 2645 "game.c"
	}
}

guint8
game_get_n_opponent_tiles (Game* self)
{
	guint8 result;
	guint8 _tmp0_ = 0U;
	Player _tmp1_;
#line 83 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 83 "../src/game.vala"
	_tmp1_ = self->priv->_current_color;
#line 83 "../src/game.vala"
	if (_tmp1_ == PLAYER_DARK) {
#line 2661 "game.c"
		guint8 _tmp2_;
		guint8 _tmp3_;
#line 83 "../src/game.vala"
		_tmp2_ = game_get_n_light_tiles (self);
#line 83 "../src/game.vala"
		_tmp3_ = _tmp2_;
#line 83 "../src/game.vala"
		_tmp0_ = _tmp3_;
#line 2670 "game.c"
	} else {
		guint8 _tmp4_;
		guint8 _tmp5_;
#line 83 "../src/game.vala"
		_tmp4_ = game_get_n_dark_tiles (self);
#line 83 "../src/game.vala"
		_tmp5_ = _tmp4_;
#line 83 "../src/game.vala"
		_tmp0_ = _tmp5_;
#line 2680 "game.c"
	}
#line 83 "../src/game.vala"
	result = _tmp0_;
#line 83 "../src/game.vala"
	return result;
#line 2686 "game.c"
}

static void
game_set_n_opponent_tiles (Game* self,
                           guint8 value)
{
	Player _tmp0_;
#line 84 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/game.vala"
	_tmp0_ = self->priv->_current_color;
#line 85 "../src/game.vala"
	if (_tmp0_ == PLAYER_DARK) {
#line 86 "../src/game.vala"
		self->priv->_n_light_tiles = value;
#line 2702 "game.c"
	} else {
#line 88 "../src/game.vala"
		self->priv->_n_dark_tiles = value;
#line 2706 "game.c"
	}
}

gboolean
game_get_alternative_start (Game* self)
{
	gboolean result;
#line 96 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 96 "../src/game.vala"
	result = self->priv->_alternative_start;
#line 96 "../src/game.vala"
	return result;
#line 2720 "game.c"
}

static void
game_set_alternative_start (Game* self,
                            gboolean value)
{
#line 96 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/game.vala"
	self->priv->_alternative_start = value;
#line 2731 "game.c"
}

static void
g_cclosure_user_marshal_VOID__UCHAR_UCHAR_ENUM (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UCHAR_UCHAR_ENUM) (gpointer data1, guint8 arg_1, guint8 arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__UCHAR_UCHAR_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 23 "../src/game.vala"
	g_return_if_fail (n_param_values == 4);
#line 23 "../src/game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 23 "../src/game.vala"
		data1 = closure->data;
#line 23 "../src/game.vala"
		data2 = param_values->data[0].v_pointer;
#line 2756 "game.c"
	} else {
#line 23 "../src/game.vala"
		data1 = param_values->data[0].v_pointer;
#line 23 "../src/game.vala"
		data2 = closure->data;
#line 2762 "game.c"
	}
#line 23 "../src/game.vala"
	callback = (GMarshalFunc_VOID__UCHAR_UCHAR_ENUM) (marshal_data ? marshal_data : cc->callback);
#line 23 "../src/game.vala"
	callback (data1, g_value_get_uchar (param_values + 1), g_value_get_uchar (param_values + 2), g_value_get_enum (param_values + 3), data2);
#line 2768 "game.c"
}

static GObject *
game_constructor (GType type,
                  guint n_construct_properties,
                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Game * self;
	guint8 _tmp0_;
	guint8 _tmp1_;
	Player* _tmp2_;
#line 98 "../src/game.vala"
	parent_class = G_OBJECT_CLASS (game_parent_class);
#line 98 "../src/game.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 98 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 100 "../src/game.vala"
	_tmp0_ = self->priv->_size;
#line 100 "../src/game.vala"
	_tmp1_ = self->priv->_size;
#line 100 "../src/game.vala"
	_tmp2_ = g_new0 (Player, _tmp0_ * _tmp1_);
#line 100 "../src/game.vala"
	self->priv->tiles = (g_free (self->priv->tiles), NULL);
#line 100 "../src/game.vala"
	self->priv->tiles = _tmp2_;
#line 100 "../src/game.vala"
	self->priv->tiles_length1 = _tmp0_;
#line 100 "../src/game.vala"
	self->priv->tiles_length2 = _tmp1_;
#line 98 "../src/game.vala"
	return obj;
#line 2804 "game.c"
}

static void
game_class_init (GameClass * klass,
                 gpointer klass_data)
{
#line 23 "../src/game.vala"
	game_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/game.vala"
	g_type_class_adjust_private_offset (klass, &Game_private_offset);
#line 23 "../src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
#line 23 "../src/game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
#line 23 "../src/game.vala"
	G_OBJECT_CLASS (klass)->constructor = game_constructor;
#line 23 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
#line 23 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SIZE_PROPERTY, game_properties[GAME_SIZE_PROPERTY] = g_param_spec_uchar ("size", "size", "size", 0, G_MAXUINT8, (guint8) 8, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_COLOR_PROPERTY, game_properties[GAME_CURRENT_COLOR_PROPERTY] = g_param_spec_enum ("current-color", "current-color", "current-color", TYPE_PLAYER, PLAYER_DARK, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_NUMBER_OF_MOVES_PROPERTY, game_properties[GAME_NUMBER_OF_MOVES_PROPERTY] = g_param_spec_uchar ("number-of-moves", "number-of-moves", "number-of-moves", 0, G_MAXUINT8, (guint8) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY, game_properties[GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY] = g_param_spec_boolean ("current-player-can-move", "current-player-can-move", "current-player-can-move", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_IS_COMPLETE_PROPERTY, game_properties[GAME_IS_COMPLETE_PROPERTY] = g_param_spec_boolean ("is-complete", "is-complete", "is-complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_INITIAL_NUMBER_OF_TILES_PROPERTY, game_properties[GAME_INITIAL_NUMBER_OF_TILES_PROPERTY] = g_param_spec_uchar ("initial-number-of-tiles", "initial-number-of-tiles", "initial-number-of-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_TILES_PROPERTY, game_properties[GAME_N_TILES_PROPERTY] = g_param_spec_uchar ("n-tiles", "n-tiles", "n-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_LIGHT_TILES_PROPERTY, game_properties[GAME_N_LIGHT_TILES_PROPERTY] = g_param_spec_uchar ("n-light-tiles", "n-light-tiles", "n-light-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_DARK_TILES_PROPERTY, game_properties[GAME_N_DARK_TILES_PROPERTY] = g_param_spec_uchar ("n-dark-tiles", "n-dark-tiles", "n-dark-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_CURRENT_TILES_PROPERTY, game_properties[GAME_N_CURRENT_TILES_PROPERTY] = g_param_spec_uchar ("n-current-tiles", "n-current-tiles", "n-current-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_OPPONENT_TILES_PROPERTY, game_properties[GAME_N_OPPONENT_TILES_PROPERTY] = g_param_spec_uchar ("n-opponent-tiles", "n-opponent-tiles", "n-opponent-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_ALTERNATIVE_START_PROPERTY, game_properties[GAME_ALTERNATIVE_START_PROPERTY] = g_param_spec_boolean ("alternative-start", "alternative-start", "alternative-start", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game.vala"
	game_signals[GAME_TURN_ENDED_SIGNAL] = g_signal_new ("turn-ended", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 23 "../src/game.vala"
	game_signals[GAME_SQUARE_CHANGED_SIGNAL] = g_signal_new ("square-changed", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UCHAR_UCHAR_ENUM, G_TYPE_NONE, 3, G_TYPE_UCHAR, G_TYPE_UCHAR, TYPE_PLAYER);
#line 2851 "game.c"
}

static void
game_instance_init (Game * self,
                    gpointer klass)
{
#line 23 "../src/game.vala"
	self->priv = game_get_instance_private (self);
#line 28 "../src/game.vala"
	self->priv->_size = (guint8) 8;
#line 32 "../src/game.vala"
	self->priv->history_index = -1;
#line 36 "../src/game.vala"
	self->priv->_current_color = PLAYER_DARK;
#line 37 "../src/game.vala"
	self->priv->_number_of_moves = (guint8) 0;
#line 40 "../src/game.vala"
	self->priv->_current_player_can_move = TRUE;
#line 41 "../src/game.vala"
	self->priv->_is_complete = FALSE;
#line 58 "../src/game.vala"
	self->priv->_n_light_tiles = (guint8) 2;
#line 64 "../src/game.vala"
	self->priv->_n_dark_tiles = (guint8) 2;
#line 2876 "game.c"
}

static void
game_finalize (GObject * obj)
{
	Game * self;
#line 23 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 26 "../src/game.vala"
	self->priv->tiles = (g_free (self->priv->tiles), NULL);
#line 31 "../src/game.vala"
	self->priv->undo_stack = (_vala_array_free (self->priv->undo_stack, self->priv->undo_stack_length1, (GDestroyNotify) g_free), NULL);
#line 23 "../src/game.vala"
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
#line 2891 "game.c"
}

GType
game_get_type (void)
{
	static volatile gsize game_type_id__volatile = 0;
	if (g_once_init_enter (&game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
		GType game_type_id;
		game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
		Game_private_offset = g_type_add_instance_private (game_type_id, sizeof (GamePrivate));
		g_once_init_leave (&game_type_id__volatile, game_type_id);
	}
	return game_type_id__volatile;
}

static void
_vala_game_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 23 "../src/game.vala"
	switch (property_id) {
#line 23 "../src/game.vala"
		case GAME_SIZE_PROPERTY:
#line 23 "../src/game.vala"
		g_value_set_uchar (value, game_get_size (self));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_CURRENT_COLOR_PROPERTY:
#line 23 "../src/game.vala"
		g_value_set_enum (value, game_get_current_color (self));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_NUMBER_OF_MOVES_PROPERTY:
#line 23 "../src/game.vala"
		g_value_set_uchar (value, game_get_number_of_moves (self));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY:
#line 23 "../src/game.vala"
		g_value_set_boolean (value, game_get_current_player_can_move (self));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_IS_COMPLETE_PROPERTY:
#line 23 "../src/game.vala"
		g_value_set_boolean (value, game_get_is_complete (self));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_INITIAL_NUMBER_OF_TILES_PROPERTY:
#line 23 "../src/game.vala"
		g_value_set_uchar (value, game_get_initial_number_of_tiles (self));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_N_TILES_PROPERTY:
#line 23 "../src/game.vala"
		g_value_set_uchar (value, game_get_n_tiles (self));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_N_LIGHT_TILES_PROPERTY:
#line 23 "../src/game.vala"
		g_value_set_uchar (value, game_get_n_light_tiles (self));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_N_DARK_TILES_PROPERTY:
#line 23 "../src/game.vala"
		g_value_set_uchar (value, game_get_n_dark_tiles (self));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_N_CURRENT_TILES_PROPERTY:
#line 23 "../src/game.vala"
		g_value_set_uchar (value, game_get_n_current_tiles (self));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_N_OPPONENT_TILES_PROPERTY:
#line 23 "../src/game.vala"
		g_value_set_uchar (value, game_get_n_opponent_tiles (self));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_ALTERNATIVE_START_PROPERTY:
#line 23 "../src/game.vala"
		g_value_set_boolean (value, game_get_alternative_start (self));
#line 23 "../src/game.vala"
		break;
#line 2990 "game.c"
		default:
#line 23 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/game.vala"
		break;
#line 2996 "game.c"
	}
}

static void
_vala_game_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 23 "../src/game.vala"
	switch (property_id) {
#line 23 "../src/game.vala"
		case GAME_SIZE_PROPERTY:
#line 23 "../src/game.vala"
		game_set_size (self, g_value_get_uchar (value));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_CURRENT_COLOR_PROPERTY:
#line 23 "../src/game.vala"
		game_set_current_color (self, g_value_get_enum (value));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_NUMBER_OF_MOVES_PROPERTY:
#line 23 "../src/game.vala"
		game_set_number_of_moves (self, g_value_get_uchar (value));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY:
#line 23 "../src/game.vala"
		game_set_current_player_can_move (self, g_value_get_boolean (value));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_IS_COMPLETE_PROPERTY:
#line 23 "../src/game.vala"
		game_set_is_complete (self, g_value_get_boolean (value));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_INITIAL_NUMBER_OF_TILES_PROPERTY:
#line 23 "../src/game.vala"
		game_set_initial_number_of_tiles (self, g_value_get_uchar (value));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_N_CURRENT_TILES_PROPERTY:
#line 23 "../src/game.vala"
		game_set_n_current_tiles (self, g_value_get_uchar (value));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_N_OPPONENT_TILES_PROPERTY:
#line 23 "../src/game.vala"
		game_set_n_opponent_tiles (self, g_value_get_uchar (value));
#line 23 "../src/game.vala"
		break;
#line 23 "../src/game.vala"
		case GAME_ALTERNATIVE_START_PROPERTY:
#line 23 "../src/game.vala"
		game_set_alternative_start (self, g_value_get_boolean (value));
#line 23 "../src/game.vala"
		break;
#line 3064 "game.c"
		default:
#line 23 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/game.vala"
		break;
#line 3070 "game.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

